(*************************************************************************)
(*                                                                       *)
(*                     Projet      Formel                                *)
(*                                                                       *)
(*                    CAML: users' library                               *)
(*                                                                       *)
(*************************************************************************)
(*                                                                       *)
(*                            LIENS                                      *)
(*                        45 rue d'Ulm                                   *)
(*                         75005 PARIS                                   *)
(*                            France                                     *)
(*                                                                       *)
(*************************************************************************)

(* fonts.ml
              Emmanuel Chailloux & Guy Cousineau
              creation : 22 March 1990                 
	      modification : 26 September 1990                             *)

module fonts;;

type font = { Name : string ;  Size : float }
;;

type font_description =
     { Name : string ; Height : float ; Width : float ;
       Descr : float vect;
       Descr_bbox : ((float * float ) * (float * float)) vect }
;;


(* somes variables of font description *)

let Courier =
{Name="Courier"; Height=12.0; Width=7.2;
Descr = [||];
Descr_bbox=[|( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.25999,0.5),(3.74,7.46973));
( (2.14,4.5),(4.86,7.5));
( (1.244,-0.5),(5.756,7.5));
( (1.5,-1.252),(5.752,7.424));
( (1.248,0.5),(5.752,7.5));
( (1.5,0.319992),(5.5,6.5));
( (2.1,4.5),(3.6,7.5));
( (3.51498,-1.5),(5.0,7.48692));
( (2.5,-1.5),(3.98499,7.48692));
( (1.496,3.5),(5.504,7.5));
( (1.004,0.752),(5.996,6.248));
( (2.1,-1.5),(3.6,1.5));
( (1.5,3.5),(6.5,3.5));
( (2.88,0.5),(4.12,1.5));
( (1.5,-0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.496,0.5),(5.504,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.144,0.5),(5.5,7.5));
( (1.248,0.5),(5.244,7.5));
( (1.888,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (2.88,0.5),(4.12,4.5));
( (2.048,-0.5),(4.12,4.5));
( (1.5,0.752),(6.5,6.248));
( (0.5,2.5),(6.5,4.5));
( (1.5,0.752),(6.5,6.248));
( (1.5,0.5),(5.5,6.5));
( (1.5,-0.499985),(5.74,7.5));
( (0.248,0.5),(6.752,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.5,0.5),(6.668,6.5));
( (0.756,0.5),(6.5,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.5,0.5),(7.004,6.5));
( (0.624,0.5),(6.376,6.5));
( (1.496,0.5),(5.504,6.5));
( (1.5,0.5),(7.0,6.5));
( (0.504,0.5),(6.372,6.5));
( (1.0,0.5),(6.5,6.5));
( (0.744,0.5),(7.256,6.5));
( (0.504,0.5),(6.256,6.5));
( (0.5,0.5),(6.5,6.67999));
( (0.504,0.5),(5.5,6.5));
( (0.5,-0.688),(6.5,6.5));
( (0.504,0.5),(6.58,6.5));
( (1.5,0.5),(5.752,6.5));
( (1.5,0.5),(6.5,6.5));
( (0.744,0.5),(6.256,6.5));
( (0.248,0.5),(6.752,6.5));
( (0.38,0.5),(6.62,6.5));
( (0.62,0.5),(6.38,6.5));
( (0.752,0.5),(6.248,6.5));
( (1.248,0.5),(5.5,6.5));
( (3.5,-1.5),(5.5,7.5));
( (1.5,-0.5),(5.5,7.5));
( (2.5,-1.5),(3.5,7.5));
( (1.496,4.5),(5.504,7.5));
( (0.5,-2.5),(7.5,-2.5));
( (3.6,4.5),(5.1,7.5));
( (1.5,0.319992),(6.496,4.5));
( (0.504,0.5),(6.5,7.5));
( (1.5,0.5),(5.79999,4.5));
( (0.5,0.5),(6.508,7.5));
( (0.5,0.5),(6.5,4.5));
( (2.0,0.5),(6.752,7.5));
( (0.5,-2.5),(6.508,4.5));
( (0.504,0.5),(6.376,7.5));
( (1.244,0.5),(5.756,7.748));
( (2.248,-2.5),(5.5,7.748));
( (1.492,0.5),(6.748,7.5));
( (1.244,0.5),(5.756,7.5));
( (0.744,0.5),(6.256,4.5));
( (0.624,0.5),(6.256,4.5));
( (1.5,0.5),(6.5,4.5));
( (0.504,-2.5),(6.5,4.5));
( (0.5,-2.5),(6.508,4.5));
( (1.0,0.5),(6.004,4.61443));
( (1.5,0.5),(5.752,4.5));
( (1.252,0.5),(6.24399,6.24));
( (0.504,0.319992),(6.256,4.5));
( (0.5,0.5),(6.5,4.5));
( (0.5,0.5),(6.5,4.5));
( (0.752,0.5),(6.248,4.5));
( (0.752,-2.5),(6.248,4.5));
( (1.368,0.5),(5.5,4.5));
( (2.504,-1.53087),(4.496,7.2896));
( (3.5,-1.5),(3.5,7.5));
( (2.504,-1.53087),(4.496,7.2896));
( (1.5,2.87448),(5.5,4.12547));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.26,-1.75999),(3.73999,4.5));
( (1.5,0.0),(5.536,7.252));
( (1.372,0.5),(6.37599,6.5));
( (0.5,1.5),(6.5,5.5));
( (0.752,0.5),(6.248,6.5));
( (1.184,-0.5),(5.876,7.5));
( (0.995987,-0.5),(6.004,7.5));
( (1.5,1.5),(5.5,5.5));
( (3.14,4.5),(3.86,7.5));
( (1.596,4.5),(5.604,7.5));
( (0.996,0.5),(6.252,4.5));
( (0.996,0.5),(3.504,4.5));
( (3.756,0.5),(6.252,4.5));
( (0.18,0.5),(6.76,7.992));
( (0.18,0.5),(6.76,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.5,3.5),(6.5,3.5));
( (1.628,-0.5),(5.372,7.5));
( (1.628,-0.5),(5.372,7.5));
( (2.88,3.5),(4.12,4.5));
( (0.0,0.0),(7.2,0.0));
( (1.004,-0.5),(6.496,7.56));
( (2.5,2.5),(4.5,4.5));
( (2.1,-1.5),(3.6,1.5));
( (1.596,-1.5),(5.604,1.5));
( (1.596,4.5),(5.604,7.5));
( (0.996,0.5),(6.252,4.5));
( (1.5,0.5),(6.5,0.5));
( (0.5,0.5),(6.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.5,-1.564),(5.5,4.5));
( (0.0,0.0),(7.2,0.0));
( (2.5,5.5),(3.5,7.5));
( (3.5,5.5),(5.5,7.5));
( (2.0,5.5),(5.0,7.5));
( (1.5,6.14749),(5.5,6.86299));
( (2.5,6.5),(5.5,6.5));
( (2.5,5.5),(5.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (2.5,5.5),(4.5,7.5));
( (2.66,-1.5),(4.18399,0.256));
( (0.0,0.0),(7.2,0.0));
( (2.1,5.5),(5.1,7.5));
( (3.59999,-1.5),(4.95599,0.5));
( (2.0,5.5),(5.0,7.5));
( (0.5,3.5),(6.5,3.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0200002,0.5),(6.5,6.5));
( (0.0,0.0),(7.2,0.0));
( (2.5,2.5),(5.256,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.76,0.5),(6.5,6.5));
( (0.368,0.128),(6.632,6.8));
( (0.499985,0.5),(6.5,6.5));
( (2.5,2.5),(5.5,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.499985,0.5),(6.5,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.244,0.5),(5.756,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.244,0.5),(5.756,7.5));
( (0.38,0.128),(6.62,4.884));
( (0.499985,0.5),(6.5,4.5));
( (0.504,0.319992),(5.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0))

|]};;


let Courier_Bold =
{Name="Courier-Bold"; Height=12.0; Width=7.2;
 Descr=[||];
 Descr_bbox=[|
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.14,0.5),(3.86,7.44333));
( (2.14,4.5),(4.86,6.5));
( (1.244,-0.26),(5.756,7.26));
( (1.5,-1.252),(5.752,7.544));
( (1.248,0.5),(5.752,7.5));
( (1.5,0.319992),(5.5,6.5));
( (2.1,4.5),(3.6,6.5));
( (3.51498,-1.5),(5.0,7.608));
( (2.5,-1.5),(3.98499,7.608));
( (1.496,3.5),(5.504,7.5));
( (1.004,0.752),(5.996,6.248));
( (2.1,-1.5),(3.6,1.5));
( (1.5,3.5),(6.5,3.5));
( (2.88,0.5),(4.12,1.5));
( (1.5,-0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.496,0.5),(5.504,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.144,0.5),(5.5,7.5));
( (1.248,0.5),(5.244,7.5));
( (1.888,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (1.5,0.5),(5.5,7.5));
( (2.88,0.5),(4.12,4.5));
( (2.048,-0.5),(4.12,4.5));
( (1.5,0.752),(6.5,6.248));
( (0.5,2.5),(6.5,4.5));
( (1.5,0.752),(6.5,6.248));
( (1.5,0.5),(5.5,6.5));
( (1.5,-0.499985),(5.74,7.5));
( (0.248,0.5),(6.752,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.5,0.5),(6.668,6.5));
( (0.756,0.5),(6.5,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.504,0.5),(6.5,6.5));
( (0.5,0.5),(7.004,6.5));
( (0.624,0.5),(6.376,6.5));
( (1.496,0.5),(5.504,6.5));
( (1.5,0.5),(7.0,6.5));
( (0.504,0.5),(6.372,6.5));
( (1.0,0.5),(6.5,6.5));
( (0.744,0.5),(7.256,6.5));
( (0.504,0.5),(6.256,6.5));
( (0.5,0.5),(6.5,6.67999));
( (0.504,0.5),(5.5,6.5));
( (0.5,-1.048),(6.5,6.5));
( (0.504,0.5),(6.58,6.5));
( (1.5,0.5),(5.752,6.5));
( (1.5,0.5),(6.5,6.5));
( (0.744,0.5),(6.256,6.5));
( (0.248,0.5),(6.752,6.5));
( (0.38,0.5),(6.62,6.5));
( (0.62,0.5),(6.38,6.5));
( (0.752,0.5),(6.248,6.5));
( (1.248,0.5),(5.5,6.5));
( (3.5,-1.5),(5.5,7.5));
( (1.5,-0.5),(5.5,7.5));
( (2.5,-1.5),(3.5,7.5));
( (1.496,4.5),(5.504,7.5));
( (0.5,-2.5),(7.5,-2.5));
( (3.6,4.5),(5.1,6.5));
( (1.5,0.319992),(6.496,4.5));
( (0.504,0.5),(6.5,7.5));
( (1.5,0.5),(5.79999,4.5));
( (0.5,0.5),(6.508,7.5));
( (0.5,0.5),(6.5,4.5));
( (2.0,0.5),(6.752,7.5));
( (0.5,-1.5),(6.508,4.5));
( (0.504,0.5),(6.376,7.5));
( (1.244,0.5),(5.756,7.748));
( (2.248,-1.5),(5.5,7.748));
( (1.492,0.5),(6.748,7.5));
( (1.244,0.5),(5.756,7.5));
( (0.744,0.5),(6.256,4.5));
( (0.624,0.5),(6.256,4.5));
( (1.5,0.5),(6.5,4.5));
( (0.504,-1.5),(6.5,4.5));
( (0.5,-1.5),(6.508,4.5));
( (1.0,0.5),(6.004,4.61923));
( (1.5,0.5),(5.752,4.5));
( (1.252,0.5),(6.24399,6.36));
( (0.504,0.319992),(6.256,4.5));
( (0.5,0.5),(6.5,4.5));
( (0.5,0.5),(6.5,4.5));
( (0.752,0.5),(6.248,4.5));
( (0.752,-1.5),(6.248,4.5));
( (1.368,0.5),(5.5,4.5));
( (2.504,-1.53087),(4.496,7.25349));
( (3.5,-1.5),(3.5,7.5));
( (2.504,-1.53087),(4.496,7.25349));
( (1.5,2.87448),(5.5,4.12547));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.14,-1.64),(3.85999,4.5));
( (1.5,0.0),(5.536,7.252));
( (1.372,0.5),(6.37599,6.5));
( (0.5,1.5),(6.5,5.5));
( (0.752,0.5),(6.248,6.5));
( (1.184,-0.5),(5.876,7.5));
( (0.995987,-0.5),(6.004,7.5));
( (1.5,1.5),(5.5,5.5));
( (3.14,4.5),(3.86,6.5));
( (1.596,4.5),(5.604,7.5));
( (0.996,0.5),(6.252,4.5));
( (0.996,0.5),(3.504,4.5));
( (3.756,0.5),(6.252,4.5));
( (0.18,0.5),(6.76,8.112));
( (0.18,0.5),(6.76,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.5,3.5),(6.5,3.5));
( (1.628,-0.5),(5.372,7.5));
( (1.628,-0.5),(5.372,7.5));
( (2.88,3.5),(4.12,4.5));
( (0.0,0.0),(7.2,0.0));
( (1.004,-0.5),(6.496,7.68));
( (2.5,2.5),(5.5,5.5));
( (2.1,-1.5),(3.6,1.5));
( (1.596,-1.5),(5.604,1.5));
( (1.596,4.5),(5.604,7.5));
( (0.996,0.5),(6.252,4.5));
( (1.5,0.5),(6.5,0.5));
( (0.5,0.5),(6.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.5,-1.80399),(5.5,4.5));
( (0.0,0.0),(7.2,0.0));
( (2.5,5.5),(3.5,7.5));
( (3.5,5.5),(5.5,7.5));
( (2.0,5.5),(5.0,7.5));
( (1.5,6.14749),(5.5,6.86299));
( (2.5,6.5),(5.5,6.5));
( (2.5,5.5),(5.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (2.5,5.5),(4.5,7.5));
( (2.66,-1.5),(4.18399,0.256));
( (0.0,0.0),(7.2,0.0));
( (2.1,5.5),(5.1,7.5));
( (3.59999,-1.5),(4.95599,0.5));
( (2.0,5.5),(5.0,7.5));
( (0.5,3.5),(6.5,3.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0200002,0.5),(6.5,6.5));
( (0.0,0.0),(7.2,0.0));
( (2.5,2.5),(5.256,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.76,0.5),(6.5,6.5));
( (0.368,0.128),(6.632,6.92));
( (0.499985,0.5),(6.5,6.5));
( (2.5,2.5),(5.5,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.499985,0.5),(6.5,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.244,0.5),(5.756,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.244,0.5),(5.756,7.5));
( (0.38,0.128),(6.62,4.884));
( (0.499985,0.5),(6.5,4.5));
( (0.504,0.319992),(5.5,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0))

|]};;


let Courier_Oblique =
{Name="Courier-Oblique"; Height=12.0; Width=7.2;
Descr=[||];
Descr_bbox=[|
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.48628,0.5),(5.27673,7.46973));
( (3.45651,4.5),(6.45418,7.5));
( (1.77539,-0.5),(6.71251,7.5));
( (1.63257,-1.252),(6.84218,7.424));
( (1.94293,0.5),(6.76004,7.5));
( (1.92776,0.319992),(6.16158,6.5));
( (3.05651,4.5),(5.19418,7.5));
( (4.15126,-1.5),(6.5914,7.48692));
( (2.18115,-1.5),(4.62126,7.48692));
( (2.77452,3.5),(6.78252,7.5));
( (1.74795,0.752),(6.73995,6.248));
( (1.78116,-1.5),(3.91884,1.5));
( (2.24395,3.5),(7.24395,3.5));
( (3.03389,0.5),(4.39122,1.5));
( (1.39372,-0.5),(7.09418,7.5));
( (2.24502,0.5),(6.45543,7.5));
( (1.60228,0.5),(5.61028,7.5));
( (1.60628,0.5),(6.70613,7.5));
( (1.37276,0.5),(6.41066,7.5));
( (1.77939,0.5),(6.09418,7.5));
( (2.18958,0.5),(6.69995,7.5));
( (2.30396,0.5),(7.05667,7.5));
( (2.92798,0.5),(7.09418,7.5));
( (1.92924,0.5),(6.5284,7.5));
( (1.64532,0.5),(6.39847,7.5));
( (3.03389,0.5),(5.02889,4.5));
( (1.94172,-0.5),(5.02889,4.5));
( (2.24395,0.752),(7.82806,6.248));
( (1.03139,2.5),(7.45651,4.5));
( (1.65984,0.752),(7.24395,6.248));
( (2.62802,0.5),(6.51096,6.5));
( (2.1075,-0.499985),(6.64658,7.5));
( (0.354279,0.5),(6.85828,6.5));
( (0.610278,0.5),(7.00151,6.5));
( (1.1713,0.5),(7.84703,6.5));
( (0.862279,0.5),(7.29394,6.5));
( (0.610278,0.5),(7.50437,6.5));
( (0.610278,0.5),(7.88162,6.5));
( (1.08566,0.5),(7.84286,6.5));
( (0.730278,0.5),(7.50562,6.5));
( (1.60228,0.5),(6.88562,6.5));
( (1.79118,0.5),(8.38162,6.5));
( (0.610278,0.5),(7.50162,6.5));
( (1.10628,0.5),(7.06472,6.5));
( (0.850278,0.5),(8.51762,6.5));
( (0.862279,0.5),(7.63762,6.5));
( (1.26053,0.5),(7.26054,6.67999));
( (0.610278,0.5),(6.56169,6.5));
( (1.24278,-0.688),(7.2428,6.5));
( (0.610278,0.5),(6.68628,6.5));
( (1.63961,0.5),(6.84566,6.5));
( (2.3082,0.5),(7.88162,6.5));
( (2.04008,0.5),(7.63762,6.5));
( (1.62962,0.5),(8.13362,6.5));
( (1.67428,0.5),(8.00162,6.5));
( (0.726279,0.5),(7.62962,6.5));
( (1.98628,0.5),(7.62962,6.5));
( (1.35428,0.5),(6.62937,6.5));
( (3.18116,-1.5),(7.09418,7.5));
( (3.09418,-0.5),(5.39372,7.5));
( (2.18116,-1.5),(5.09418,7.5));
( (2.45251,4.5),(6.46051,7.5));
( (-0.0313926,-2.5),(6.96861,-2.5));
( (5.19418,4.5),(6.05651,7.5));
( (1.79543,0.319992),(6.60228,4.5));
( (0.641614,0.5),(7.03033,7.5));
( (2.03033,0.5),(6.42517,4.5));
( (1.03033,0.5),(7.09418,7.5));
( (1.03139,0.5),(7.03139,4.5));
( (2.10628,0.5),(8.29844,7.5));
( (1.0258,-2.5),(7.43103,4.5));
( (0.730278,0.5),(6.48228,7.5));
( (1.35028,0.5),(5.86228,7.748));
( (1.71661,-2.5),(6.52289,7.748));
( (1.59828,0.5),(7.20051,7.5));
( (1.35028,0.5),(5.86228,7.5));
( (0.850278,0.5),(6.36228,4.5));
( (0.730278,0.5),(6.36228,4.5));
( (2.03033,0.5),(7.03035,4.5));
( (-0.0273924,-2.5),(7.02693,4.5));
( (1.02693,-2.5),(7.43112,4.5));
( (1.10628,0.5),(6.88834,4.61443));
( (1.63475,0.5),(6.42166,4.5));
( (2.20851,0.5),(6.45651,6.24));
( (1.46051,0.319992),(6.45651,4.5));
( (1.45651,0.5),(7.45651,4.5));
( (1.45651,0.5),(7.45651,4.5));
( (0.858279,0.5),(6.95251,4.5));
( (0.220608,-2.5),(7.20451,4.5));
( (1.47428,0.5),(6.32028,4.5));
( (3.03539,-1.53087),(6.04546,7.2896));
( (3.18116,-1.5),(5.09418,7.5));
( (2.17859,-1.53087),(5.07211,7.2896));
( (2.19039,2.87448),(6.2975,4.12547));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (2.93691,-1.75999),(4.57651,4.5));
( (2.24522,0.0),(6.61545,7.252));
( (1.73028,0.5),(6.65576,6.5));
( (0.818835,1.5),(7.66906,5.5));
( (1.94684,0.5),(7.62962,6.5));
( (1.11008,-0.5),(7.43634,7.5));
( (1.39372,-0.5),(7.09418,7.5));
( (1.81884,1.5),(6.66906,5.5));
( (4.45651,4.5),(5.45418,7.5));
( (3.19018,4.5),(6.56051,7.5));
( (1.52739,0.5),(7.20851,4.5));
( (1.52739,0.5),(4.46051,4.5));
( (3.86228,0.5),(6.78339,4.5));
( (0.286279,0.5),(7.07568,7.992));
( (0.286279,0.5),(7.09418,7.5));
( (0.0,0.0),(7.2,0.0));
( (2.24395,3.5),(7.24395,3.5));
( (2.58451,-0.5),(6.32851,7.5));
( (1.94684,-0.5),(6.32851,7.5));
( (3.67156,3.5),(5.02889,4.5));
( (0.0,0.0),(7.2,0.0));
( (1.89372,-0.5),(8.10293,7.56));
( (3.12662,2.5),(5.36128,4.5));
( (1.78116,-1.5),(3.91884,1.5));
( (1.27716,-1.5),(5.92284,1.5));
( (2.55251,4.5),(7.19818,7.5));
( (1.10228,0.5),(6.78339,4.5));
( (1.60628,0.5),(6.60628,0.5));
( (1.83171,0.5),(6.84823,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.53995,-1.564),(5.40733,4.5));
( (0.0,0.0),(7.2,0.0));
( (4.09418,5.5),(4.66906,7.5));
( (4.66906,5.5),(7.09418,7.5));
( (3.16906,5.5),(6.16906,7.5));
( (2.85611,6.14749),(6.90967,6.86299));
( (3.88162,6.5),(6.88162,6.5));
( (4.09418,5.5),(7.09418,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.88914,5.5),(5.88916,7.5));
( (2.39494,-1.5),(3.97272,0.256));
( (0.0,0.0),(7.2,0.0));
( (3.26906,5.5),(6.69418,7.5));
( (3.45801,-1.5),(4.70177,0.5));
( (3.59418,5.5),(6.59418,7.5));
( (1.24395,3.5),(7.24395,3.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.126279,0.5),(7.72777,6.5));
( (0.0,0.0),(7.2,0.0));
( (3.03139,2.5),(5.84395,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.10628,0.5),(7.06472,6.5));
( (0.395207,0.128),(8.07739,6.8));
( (1.21815,0.5),(7.64162,6.5));
( (3.03139,2.5),(6.55531,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.914185,0.5),(7.03139,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.35028,0.5),(5.86228,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.35028,0.5),(6.03753,7.5));
( (0.407207,0.128),(7.65813,4.884));
( (1.00954,0.5),(7.03139,4.5));
( (0.610278,0.319992),(5.98047,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0))

|]};;


let Courier_BoldOblique =
{Name="Courier-BoldOblique"; Height=12.0; Width=7.2;
Descr=[||];
Descr_bbox=[|( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.48628,0.5),(5.36561,7.44333));
( (3.45651,4.5),(6.24162,6.5));
( (1.77539,-0.26),(6.71251,7.26));
( (1.63313,-1.252),(6.84135,7.544));
( (1.90486,0.5),(6.74457,7.5));
( (1.86417,0.319992),(6.11358,6.5));
( (3.05651,4.5),(4.98162,6.5));
( (4.16504,-1.5),(6.61713,7.608));
( (2.18115,-1.5),(4.63504,7.608));
( (2.79102,3.5),(6.79902,7.5));
( (1.74795,0.752),(6.73995,6.248));
( (1.78116,-1.5),(3.91884,1.5));
( (2.24395,3.5),(7.24395,3.5));
( (3.03389,0.5),(4.39122,1.5));
( (1.39372,-0.5),(7.09418,7.5));
( (2.21057,0.5),(6.43617,7.5));
( (1.60228,0.5),(5.61028,7.5));
( (1.60628,0.5),(6.70494,7.5));
( (1.32089,0.5),(6.42702,7.5));
( (1.77939,0.5),(6.09418,7.5));
( (2.12126,0.5),(6.69995,7.5));
( (2.26938,0.5),(7.05514,7.5));
( (2.94368,0.5),(7.09418,7.5));
( (1.89529,0.5),(6.54349,7.5));
( (1.65077,0.5),(6.40903,7.5));
( (3.03389,0.5),(5.02889,4.5));
( (1.94172,-0.5),(5.02889,4.5));
( (2.24395,0.752),(7.82806,6.248));
( (1.03139,2.5),(7.45651,4.5));
( (1.65984,0.752),(7.24395,6.248));
( (2.62307,0.5),(6.52859,6.5));
( (2.1075,-0.499985),(6.64658,7.5));
( (0.354279,0.5),(6.85828,6.5));
( (0.610278,0.5),(7.01468,6.5));
( (1.14078,0.5),(7.84433,6.5));
( (0.862279,0.5),(7.27167,6.5));
( (0.610278,0.5),(7.50437,6.5));
( (0.610278,0.5),(7.88162,6.5));
( (1.08736,0.5),(7.84164,6.5));
( (0.730278,0.5),(7.50562,6.5));
( (1.60228,0.5),(6.88562,6.5));
( (1.7292,0.5),(8.38162,6.5));
( (0.610278,0.5),(7.50162,6.5));
( (1.10628,0.5),(7.02347,6.5));
( (0.850278,0.5),(8.51762,6.5));
( (0.862279,0.5),(7.63762,6.5));
( (1.23625,0.5),(7.23627,6.67999));
( (0.610278,0.5),(6.57292,6.5));
( (1.21783,-1.048),(7.21785,6.5));
( (0.610278,0.5),(6.68628,6.5));
( (1.6435,0.5),(6.84426,6.5));
( (2.3082,0.5),(7.88162,6.5));
( (1.9981,0.5),(7.63762,6.5));
( (1.62962,0.5),(8.13362,6.5));
( (1.67428,0.5),(8.00162,6.5));
( (0.726279,0.5),(7.62962,6.5));
( (1.98628,0.5),(7.62962,6.5));
( (1.35428,0.5),(6.62937,6.5));
( (3.18116,-1.5),(7.09418,7.5));
( (3.09418,-0.5),(5.39372,7.5));
( (2.18116,-1.5),(5.09418,7.5));
( (2.45251,4.5),(6.46051,7.5));
( (-0.0313926,-2.5),(6.96861,-2.5));
( (4.98162,4.5),(6.05651,6.5));
( (1.75777,0.319992),(6.60228,4.5));
( (0.645029,0.5),(7.00706,7.5));
( (2.00706,0.5),(6.42176,4.5));
( (1.00706,0.5),(7.09418,7.5));
( (1.03139,0.5),(7.03139,4.5));
( (2.10628,0.5),(8.29844,7.5));
( (1.03711,-1.5),(7.43013,4.5));
( (0.730278,0.5),(6.48228,7.5));
( (1.35028,0.5),(5.86228,7.748));
( (1.92916,-1.5),(6.45651,7.748));
( (1.59828,0.5),(7.20051,7.5));
( (1.35028,0.5),(5.86228,7.5));
( (0.850278,0.5),(6.36228,4.5));
( (0.730278,0.5),(6.36228,4.5));
( (2.00706,0.5),(7.00707,4.5));
( (0.185165,-1.5),(7.00156,4.5));
( (1.00156,-1.5),(7.42722,4.5));
( (1.10628,0.5),(6.905,4.61923));
( (1.63915,0.5),(6.41965,4.5));
( (2.20851,0.5),(6.46138,6.36));
( (1.46051,0.319992),(6.45651,4.5));
( (1.45651,0.5),(7.45651,4.5));
( (1.45651,0.5),(7.45651,4.5));
( (0.858279,0.5),(6.95251,4.5));
( (0.433165,-1.5),(7.20451,4.5));
( (1.47428,0.5),(6.32028,4.5));
( (3.03539,-1.53087),(6.03778,7.25349));
( (3.18116,-1.5),(5.09418,7.5));
( (2.17859,-1.53087),(5.07979,7.25349));
( (2.19039,2.87448),(6.2975,4.12547));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (2.86793,-1.64),(4.57651,4.5));
( (2.24522,0.0),(6.61545,7.252));
( (1.73028,0.5),(6.59821,6.5));
( (0.818835,1.5),(7.66906,5.5));
( (1.94684,0.5),(7.62962,6.5));
( (1.11008,-0.5),(7.4349,7.5));
( (1.39372,-0.5),(7.09418,7.5));
( (1.81884,1.5),(6.66906,5.5));
( (4.45651,4.5),(5.24162,6.5));
( (3.19018,4.5),(6.56051,7.5));
( (1.52739,0.5),(7.20851,4.5));
( (1.52739,0.5),(4.46051,4.5));
( (3.86228,0.5),(6.78339,4.5));
( (0.286279,0.5),(6.91657,8.112));
( (0.286279,0.5),(7.09418,7.5));
( (0.0,0.0),(7.2,0.0));
( (2.24395,3.5),(7.24395,3.5));
( (2.58451,-0.5),(6.32851,7.5));
( (1.94684,-0.5),(6.32851,7.5));
( (3.67156,3.5),(5.02889,4.5));
( (0.0,0.0),(7.2,0.0));
( (1.89372,-0.5),(8.12844,7.68));
( (3.17423,2.5),(6.52623,5.5));
( (1.78116,-1.5),(3.91884,1.5));
( (1.27716,-1.5),(5.92284,1.5));
( (2.55251,4.5),(7.19818,7.5));
( (1.10228,0.5),(6.78339,4.5));
( (1.60628,0.5),(6.60628,0.5));
( (1.84799,0.5),(6.848,7.5));
( (0.0,0.0),(7.2,0.0));
( (1.46344,-1.80399),(5.35631,4.5));
( (0.0,0.0),(7.2,0.0));
( (4.09418,5.5),(4.66906,7.5));
( (4.66906,5.5),(7.09418,7.5));
( (3.16906,5.5),(6.16906,7.5));
( (2.85611,6.14749),(6.90967,6.86299));
( (3.88162,6.5),(6.88162,6.5));
( (4.09418,5.5),(7.09418,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (3.88914,5.5),(5.88916,7.5));
( (2.39494,-1.5),(3.97272,0.256));
( (0.0,0.0),(7.2,0.0));
( (3.26906,5.5),(6.69418,7.5));
( (3.45801,-1.5),(4.70177,0.5));
( (3.59418,5.5),(6.59418,7.5));
( (1.24395,3.5),(7.24395,3.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.126279,0.5),(7.72777,6.5));
( (0.0,0.0),(7.2,0.0));
( (3.03139,2.5),(5.84395,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.10628,0.5),(7.02347,6.5));
( (0.395207,0.128),(8.10289,6.92));
( (1.21495,0.5),(7.64162,6.5));
( (3.03139,2.5),(6.56797,6.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.895065,0.5),(7.03139,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.35028,0.5),(5.86228,4.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (1.35028,0.5),(6.02344,7.5));
( (0.407207,0.128),(7.65813,4.884));
( (1.00597,0.5),(7.03139,4.5));
( (0.610278,0.319992),(5.9335,7.5));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0));
( (0.0,0.0),(7.2,0.0))

|]};;


let Times_Roman =
{Name="Times-Roman"; Height=12.0; Width=12.0; 
Descr=[|3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
4.89587;
6.0;
6.0;
9.99591;
9.336;
3.99591;
3.99591;
3.99591;
6.0;
6.76794;
3.0;
3.99591;
3.0;
3.336;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
3.336;
3.336;
6.76794;
6.76794;
6.76794;
5.32782;
11.0519;
8.66382;
8.00391;
8.00391;
8.66382;
7.33191;
6.672;
8.66382;
8.66382;
3.99591;
4.66791;
8.66382;
7.33191;
10.6679;
8.66382;
8.66382;
6.672;
8.66382;
8.00391;
6.672;
7.33191;
8.66382;
8.66382;
11.3278;
8.66382;
8.66382;
7.33191;
3.99591;
3.336;
3.99591;
5.62793;
6.0;
3.99591;
5.32782;
6.0;
5.32782;
6.0;
5.32782;
3.99591;
6.0;
6.0;
3.336;
3.336;
6.0;
3.336;
9.336;
6.0;
6.0;
6.0;
6.0;
3.99591;
4.66791;
3.336;
6.0;
6.0;
8.66382;
6.0;
6.0;
5.32782;
5.75995;
2.39996;
5.75995;
6.49182;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
6.0;
6.0;
2.00391;
6.0;
6.0;
6.0;
6.0;
2.15991;
5.32782;
6.0;
3.99591;
3.99591;
6.672;
6.672;
3.0;
6.0;
6.0;
6.0;
3.0;
3.0;
5.43585;
4.19989;
3.99591;
5.32782;
5.32782;
6.0;
12.0;
12.0;
3.0;
5.32782;
3.0;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.99591;
12.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
10.6679;
3.0;
3.31183;
3.0;
3.0;
3.0;
3.0;
7.33191;
8.66382;
10.6679;
3.71997;
3.0;
3.0;
3.0;
3.0;
3.0;
8.00391;
3.0;
3.0;
3.0;
3.336;
3.0;
3.0;
3.336;
6.0;
8.66382;
6.0;
3.0;
3.0;
3.0;
3.0
|];
Descr_bbox=[|( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (1.31,0.31),(2.69,7.74));
( (0.481746,5.56),(4.564,8.44));
( (-0.446,0.26),(5.446,7.74));
( (0.454,-0.718),(5.468,8.43));
( (0.544,0.32),(9.656,7.842));
( (0.448,0.682),(9.426,7.692));
( (1.666,4.536),(3.334,7.464));
( (0.49,-1.74),(3.55,7.74));
( (0.45,-1.74),(3.51,7.74));
( (1.136,2.432),(5.876,7.568));
( (-0.024,-0.048),(6.024,6.012));
( (0.666,-1.464),(2.334,1.464));
( (0.524,2.622),(3.476,3.378));
( (1.31,0.31),(2.69,1.69));
( (-0.372,-1.74),(3.372,7.74));
( (0.418,0.338),(5.576,7.656));
( (1.254,0.416),(4.65,7.74));
( (0.788,0.544),(6.128,7.432));
( (0.788,0.266),(5.432,7.354));
( (0.26,0.26),(5.686,7.74));
( (0.644,0.29),(5.564,7.786));
( (0.448,0.332),(5.558,7.74));
( (0.326,0.26),(5.474,7.444));
( (0.544,0.35),(5.666,7.656));
( (0.448,-0.62),(5.714,7.656));
( (1.31,0.103193),(2.69,4.69));
( (0.274,-1.464),(1.942,4.69));
( (0.446,0.628),(6.554,6.372));
( (0.476,1.616),(6.524,4.384));
( (0.446,0.628),(6.554,6.372));
( (1.002,0.224773),(5.154,7.674));
( (0.232,-1.752),(9.77,7.752));
( (-0.28,0.386),(8.61,7.74));
( (0.236,0.278),(6.69,7.74));
( (0.304,0.73),(7.552,7.746));
( (0.332,0.26),(8.654,7.722));
( (0.332,0.254),(6.934,7.746));
( (0.332,0.386),(6.406,7.746));
( (0.31,0.254),(8.422,7.74));
( (0.332,0.386),(8.668,7.614));
( (0.212,0.386),(3.788,7.614));
( (0.396,0.272),(4.788,7.614));
( (0.308,0.386),(8.576,7.614));
( (0.332,0.254),(7.364,7.614));
( (0.572,0.386),(10.668,7.614));
( (0.572,0.218),(8.428,7.614));
( (0.316,0.284),(8.678,7.812));
( (0.332,0.386),(6.654,7.722));
( (0.316,-2.614),(8.834,7.716));
( (0.368,0.386),(7.998,7.728));
( (0.136,0.272),(5.636,7.746));
( (0.556,0.386),(7.468,7.252));
( (0.332,0.73),(8.392,7.614));
( (0.354,0.26),(8.292,7.614));
( (0.42,0.26),(11.31,7.614));
( (0.57,0.386),(8.32,7.614));
( (-0.128,0.386),(8.044,7.614));
( (0.056,0.272),(7.136,7.728));
( (1.544,-1.65),(4.076,7.65));
( (-1.432,0.26),(4.432,7.74));
( (-0.0759999,-1.65),(2.456,7.65));
( (0.562,3.26),(5.438,7.74));
( (0.5,-1.294),(6.5,-0.706));
( (0.666,4.536),(2.334,7.464));
( (0.472,0.646),(5.398,4.638));
( (-0.29,0.308),(5.528,7.74));
( (0.538,0.58),(5.182,4.674));
( (0.484,0.676),(6.314,7.74));
( (0.58,0.598),(5.368,4.71));
( (0.494,0.416),(4.85,7.692));
( (-0.00199997,-2.336),(5.776,4.668));
( (-0.266,0.416),(6.266,7.74));
( (0.578,0.416),(3.422,7.56338));
( (-0.706,-2.558),(2.582,7.56338));
( (-0.41,0.416),(5.578,7.74));
( (0.566,0.416),(3.434,7.74));
( (-0.266,0.416),(8.266,4.318));
( (-0.266,0.416),(6.266,4.324));
( (0.448,0.32),(5.552,4.68));
( (-0.386,-2.584),(5.516,4.336));
( (0.484,-2.584),(6.386,4.74));
( (-0.41,0.416),(3.622,4.372));
( (0.628,0.362),(4.42,4.638));
( (-0.29,0.676),(2.986,6.276));
( (-0.266,0.652),(5.254,4.584));
( (0.6,0.26),(5.558,4.584));
( (0.696,0.26),(8.48,4.584));
( (0.37,0.416),(5.26,4.584));
( (0.624,-2.606),(5.322,4.584));
( (0.044,0.314),(4.76,4.686));
( (1.656,-1.776),(4.428,7.752));
( (0.616,0.26),(1.384,7.74));
( (1.572,-1.776),(4.344,7.752));
( (0.476,2.474),(6.524,4.526));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (1.31,-2.74),(2.69,4.69));
( (0.37,-0.962),(5.542,6.114));
( (0.338,0.332),(6.098,7.644));
( (-2.354,0.26),(4.354,7.74));
( (-0.306,0.386),(6.234,7.614));
( (0.376,-2.65),(5.48,7.66));
( (0.7,-1.626),(5.312,7.626));
( (-0.462,1.586),(6.45,7.45));
( (0.436,5.56),(1.564,8.44));
( (0.51739,4.536),(4.334,7.464));
( (0.274597,0.624),(5.262,5.376));
( (0.442,0.624),(3.262,5.376));
( (0.738,0.624),(3.558,5.376));
( (0.686,0.416),(6.326,7.65));
( (0.638,0.416),(6.266,8.016));
( (0.0,0.0),(3.0,0.0));
( (0.416,2.706),(6.584,3.294));
( (0.19,-1.74),(4.822,7.74));
( (0.19,-1.74),(4.81,7.74));
( (1.31,2.31),(2.69,3.69));
( (0.0,0.0),(3.0,0.0));
( (-0.268,-3.176),(4.756,7.252));
( (0.488,2.5),(3.5,5.5));
( (1.666,-1.464),(3.334,1.464));
( (0.666,-1.464),(5.29591,1.464));
( (0.666,4.536),(5.29591,7.464));
( (0.738,0.612),(5.7254,5.364));
( (1.31,0.31),(10.69,1.69));
( (-0.528,0.32),(12.656,7.662));
( (0.0,0.0),(3.0,0.0));
( (0.846,-2.65),(4.998,4.69));
( (0.0,0.0),(3.0,0.0));
( (0.638,5.688),(3.362,7.74));
( (0.656,5.688),(3.344,7.74));
( (0.628,5.38),(4.372,7.384));
( (-0.486,6.118),(3.486,7.39));
( (0.628,6.676),(4.372,7.324));
( (0.272,5.64),(3.692,7.524));
( (1.4,6.4),(2.6,7.6));
( (0.406,6.4),(3.59497,7.6));
( (0.0,0.0),(3.0,0.0));
( (1.272,6.272),(2.728,7.728));
( (0.942,-2.71),(3.45,0.472));
( (0.0,0.0),(3.0,0.0));
( (0.316,6.468),(4.72,8.532));
( (0.718,-1.746),(2.842,-0.006));
( (0.628,5.616),(4.372,7.74));
( (-0.59,2.706),(11.59,3.294));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.388,0.254),(10.862,7.746));
( (0.0,0.0),(3.0,0.0));
( (0.658,3.32),(2.906,7.74));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.332,0.254),(7.364,7.614));
( (0.316,-0.508),(8.678,8.412));
( (0.328,0.17),(10.848,7.83));
( (0.652,3.32),(3.348,7.608));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.478,0.604),(7.834,4.674));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.578,0.416),(3.422,4.74));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.566,0.416),(3.434,7.74));
( (0.466,-0.856),(5.534,5.772));
( (0.448,0.32),(8.744,4.68));
( (-0.242,0.32),(5.564,7.644));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0))

|]};;


let Times_Bold =
{Name="Times-Bold"; Width=12.0; Height=12.0;
Descr=[|3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
6.65991;
6.0;
6.0;
12.0;
9.99591;
3.99591;
3.99591;
3.99591;
6.0;
6.8399;
3.0;
3.99591;
3.0;
3.336;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
3.99591;
3.99591;
6.8399;
6.8399;
6.8399;
6.0;
11.1599;
8.66382;
8.00391;
8.66382;
8.66382;
8.00391;
7.33191;
9.336;
9.336;
4.66791;
6.0;
9.336;
8.00391;
11.3278;
8.66382;
9.336;
7.33191;
9.336;
8.66382;
6.672;
8.00391;
8.66382;
8.66382;
12.0;
8.66382;
8.66382;
8.00391;
3.99591;
3.336;
3.99591;
6.97192;
6.0;
3.99591;
6.0;
6.672;
5.32782;
6.672;
5.32782;
3.99591;
6.0;
6.672;
3.336;
3.99591;
6.672;
3.336;
9.99591;
6.672;
6.0;
6.672;
6.672;
5.32782;
4.66791;
3.99591;
6.672;
6.0;
8.66382;
6.0;
6.0;
5.32782;
4.72797;
2.63983;
4.72797;
6.23987;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
6.0;
6.0;
2.00391;
6.0;
6.0;
6.0;
6.0;
3.336;
6.0;
6.0;
3.99591;
3.99591;
6.672;
6.672;
3.0;
6.0;
6.0;
6.0;
3.0;
3.0;
6.47992;
4.19989;
3.99591;
6.0;
6.0;
6.0;
12.0;
12.0;
3.0;
6.0;
3.0;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.99591;
12.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
12.0;
3.0;
3.59985;
3.0;
3.0;
3.0;
3.0;
8.00391;
9.336;
12.0;
3.95984;
3.0;
3.0;
3.0;
3.0;
3.0;
8.66382;
3.0;
3.0;
3.0;
3.336;
3.0;
3.0;
3.336;
6.0;
8.66382;
6.672;
3.0;
3.0;
3.0;
3.0
|];
Descr_bbox=[|( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.836,0.01),(3.164,7.626));
( (1.04321,4.086),(4.888,7.914));
( (-0.534,0.374),(6.396,7.626));
( (0.576,-0.868),(5.798,8.448));
( (1.72,0.00200002),(10.83,7.842));
( (0.662,-0.02),(8.782,8.1));
( (0.662,4.32),(3.386,8.146));
( (0.852,-1.692),(3.876,8.692));
( (0.124,-1.692),(3.148,8.692));
( (0.184,2.932),(4.888,8.068));
( (0.68,-0.32),(6.32,5.32));
( (0.68,-2.072),(3.104,2.404));
( (0.576,1.81),(3.396,3.19));
( (1.016,0.01),(2.984,1.978));
( (-0.318,0.374),(3.018,8.626));
( (-0.314,0.32),(6.314,7.674));
( (0.678,0.374),(5.322,7.626));
( (-0.0859999,0.232),(5.374,7.842));
( (-0.14,0.164),(5.452,7.998));
( (0.214,0.374),(5.602,7.626));
( (-0.03,-0.118),(5.31,7.792));
( (-0.224,-0.262),(6.236,7.698));
( (0.35,0.374),(5.69,7.792));
( (-0.508,0.068),(6.368,8.034));
( (-0.2,0.35),(6.5,8.19));
( (1.016,0.01),(2.984,5.984));
( (0.644,-2.072),(3.068,5.984));
( (0.954,-0.32),(6.654,5.32));
( (0.6,1.056),(6.24,4.944));
( (0.346,-0.32),(6.046,5.32));
( (0.612,0.016),(4.924,8.046));
( (0.136,-1.902),(10.932,7.848));
( (0.486,0.374),(8.574,7.626));
( (0.0620001,0.374),(7.416,7.626));
( (0.986,0.248),(7.824,7.656));
( (0.0620001,0.374),(8.338,7.626));
( (0.0620001,0.374),(7.232,7.626));
( (0.0620001,0.374),(6.62,7.626));
( (0.986,0.332),(8.938,7.656));
( (0.0620001,0.374),(8.938,7.626));
( (-0.0879999,0.374),(4.1,7.614));
( (0.1,-0.782),(5.938,7.626));
( (0.0620001,0.374),(8.846,7.626));
( (0.0620001,0.374),(7.668,7.626));
( (0.186,0.374),(10.938,7.626));
( (0.21,0.254),(8.694,7.626));
( (0.992,0.338),(9.008,7.656));
( (0.0620001,0.374),(7.248,7.626));
( (-0.00799997,-2.544),(9.452,7.656));
( (0.0620001,0.374),(7.962,7.626));
( (-0.49,0.176),(6.616,8.094));
( (0.406,0.374),(7.594,7.626));
( (0.0620001,0.11),(8.694,7.626));
( (0.408,0.368),(8.496,7.626));
( (0.0200002,0.362),(11.944,7.614));
( (0.276,0.374),(8.34,7.626));
( (0.00400012,0.374),(8.14,7.614));
( (0.086,0.278),(7.68,7.722));
( (0.93,-1.68),(3.606,7.68));
( (-0.174,0.374),(3.162,9.578));
( (0.394,-1.68),(3.07,7.68));
( (1.184,3.39),(5.792,8.19));
( (-0.024,-2.944),(6.024,-2.056));
( (0.596,3.854),(3.32,7.68));
( (-0.182,0.23),(5.5,6.052));
( (0.668,-0.418),(6.296,7.626));
( (-0.65,-0.328),(5.37,5.95));
( (-0.698,-0.352),(6.428,7.626));
( (-0.53,-0.202),(5.262,6.082));
( (0.536,0.374),(4.31,7.77));
( (-0.17,-2.884),(5.554,5.896));
( (0.668,0.374),(6.332,7.626));
( (0.668,0.374),(3.332,7.888));
( (-1.096,-2.866),(2.888,7.888));
( (0.668,0.374),(6.716,7.626));
( (0.668,0.374),(3.332,7.626));
( (0.572,0.374),(9.332,5.914));
( (0.668,0.374),(6.332,5.902));
( (-0.44,0.308),(6.44,5.668));
( (0.668,-2.626),(6.428,5.986));
( (-0.26,-2.626),(6.452,6.472));
( (0.668,0.374),(4.96,5.954));
( (-0.192,0.14),(4.274,5.722));
( (0.608,0.206),(4.184,7.786));
( (0.668,0.278),(6.428,5.626));
( (-0.242,0.374),(5.266,5.626));
( (-0.212,0.374),(8.176,5.626));
( (0.132,0.374),(5.856,5.626));
( (-0.346,-3.41),(6.146,5.626));
( (0.146,0.344),(4.644,5.656));
( (0.82,-1.716),(4.396,7.716));
( (1.056,-2.34),(1.944,8.64));
( (0.604,-1.716),(4.18,7.716));
( (0.254,2.278),(5.722,5.71));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.836,-2.638),(3.164,5.984));
( (-0.11,-1.57),(5.966,7.048));
( (0.206,0.272),(5.626,7.836));
( (-1.632,0.374),(4.452,7.626));
( (0.024,0.374),(6.516,7.626));
( (-0.208,-1.854),(6.196,8.854));
( (0.708,-1.788),(5.304,7.788));
( (0.36,1.336),(5.664,7.676));
( (0.612,3.798),(2.388,7.626));
( (-0.153386,3.498),(6.362,7.674));
( (0.196,0.558),(5.304,5.43));
( (0.178,0.558),(3.322,5.43));
( (0.666,0.564),(3.81,5.436));
( (0.5,0.374),(6.332,7.83));
( (0.572,0.374),(6.332,7.74));
( (0.0,0.0),(3.0,0.0));
( (-0.048,1.954),(6.0,3.046));
( (0.0400001,-1.688),(4.96,7.65));
( (1.04,-1.65),(5.96,7.65));
( (0.756,2.756),(2.244,4.244));
( (0.0,0.0),(3.0,0.0));
( (0.76,-2.502),(6.688,7.95));
( (0.988,2.0),(4.0,5.0));
( (0.662,-1.68),(3.386,2.146));
( (-0.32,-1.674),(6.20612,2.502));
( (-0.32,4.326),(6.20612,8.502));
( (0.684,0.564),(5.804,5.436));
( (1.016,0.01),(10.983,1.978));
( (-0.106,-0.184),(11.752,8.196));
( (0.0,0.0),(3.0,0.0));
( (1.076,-3.07),(5.4,5.984));
( (0.0,0.0),(3.0,0.0));
( (0.106,6.276),(2.806,8.412));
( (1.224,6.276),(3.924,8.412));
( (-0.156,5.868),(3.156,7.908));
( (0.35,6.816),(3.656,8.184));
( (0.408,6.158),(3.564,6.842));
( (0.332,6.068),(3.68,7.724));
( (1.84,5.84),(3.16,7.16));
( (-0.076,6.924),(3.08057,8.076));
( (0.0,0.0),(3.0,0.0));
( (0.296,6.296),(3.704,8.704));
( (0.504,-2.836),(3.756,-0.376));
( (0.0,0.0),(3.0,0.0));
( (0.188,6.468),(3.694,9.096));
( (0.606,-2.166),(3.582,1.086));
( (-0.096,6.068),(3.096,8.108));
( (-0.024,1.93),(12.096,3.07));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.522,0.374),(11.118,7.626));
( (0.0,0.0),(3.0,0.0));
( (-0.214,3.164),(3.406,7.854));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0620001,0.374),(7.656,7.626));
( (0.992,-0.352),(9.008,8.256));
( (-0.00199997,0.00200002),(12.238,7.71));
( (-0.37,3.164),(4.358,7.632));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.182,0.206),(8.25,6.088));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.668,0.374),(3.332,5.626));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0440001,0.374),(3.956,7.626));
( (-0.398,-0.622),(6.404,6.598));
( (-0.434,0.14),(8.256,6.058));
( (0.572,-0.262),(6.152,7.824));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0))

|]};;


let Times_Italic =
{Name="Times-Italic"; Width=12.0; Height=12.0;
Descr=[|3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
5.03998;
6.0;
6.0;
9.99591;
9.336;
3.99591;
3.99591;
3.99591;
6.0;
8.09985;
3.0;
3.99591;
3.0;
3.336;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
3.99591;
3.99591;
8.09985;
8.09985;
8.09985;
6.0;
11.04;
7.33191;
7.33191;
8.00391;
8.66382;
7.33191;
7.33191;
8.66382;
8.66382;
3.99591;
5.32782;
8.00391;
6.672;
9.99591;
8.00391;
8.66382;
7.33191;
8.66382;
7.33191;
6.0;
6.672;
8.66382;
7.33191;
9.99591;
7.33191;
6.672;
6.672;
4.66791;
3.336;
4.66791;
5.06396;
6.0;
3.99591;
6.0;
6.0;
5.32782;
6.0;
5.32782;
3.336;
6.0;
6.0;
3.336;
3.336;
5.32782;
3.336;
8.66382;
6.0;
6.0;
6.0;
6.0;
4.66791;
4.66791;
3.336;
6.0;
5.32782;
8.00391;
5.32782;
5.32782;
4.66791;
4.79993;
3.29993;
4.79993;
6.49182;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
4.66791;
6.0;
6.0;
2.00391;
6.0;
6.0;
6.0;
6.0;
2.56787;
6.672;
6.0;
3.99591;
3.99591;
6.0;
6.0;
3.0;
6.0;
6.0;
6.0;
3.0;
3.0;
6.27594;
4.19989;
3.99591;
6.672;
6.672;
6.0;
10.6679;
12.0;
3.0;
6.0;
3.0;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.99591;
10.6679;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
10.6679;
3.0;
3.31183;
3.0;
3.0;
3.0;
3.0;
6.672;
8.66382;
11.3278;
3.71997;
3.0;
3.0;
3.0;
3.0;
3.0;
8.00391;
3.0;
3.0;
3.0;
3.336;
3.0;
3.0;
3.336;
6.0;
8.00391;
6.0;
3.0;
3.0;
3.0;
3.0
|];
Descr_bbox=[|( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.4,0.4),(3.448,7.674));
( (1.088,5.374),(4.64485,8.182));
( (0.188,0.392),(5.992,7.596));
( (0.344,-0.712),(5.996,8.472));
( (0.136,0.152),(9.824,7.836));
( (0.28,0.556),(8.076,7.944));
( (0.956,4.832),(2.756,7.508));
( (0.316,-1.8),(3.952,7.692));
( (0.108,-2.848),(3.672,7.788));
( (0.51,2.492),(5.502,7.508));
( (0.976,-0.048),(7.024,6.012));
( (0.944,-0.968),(2.744,1.708));
( (0.66,2.628),(3.312,3.372));
( (1.4,0.4),(2.6,1.6));
( (0.428,0.374),(3.428,7.614));
( (0.4,0.26),(5.924,8.028));
( (0.084,0.374),(4.392,7.626));
( (0.284,0.538),(5.672,7.558));
( (-0.236,0.184),(5.416,7.408));
( (-0.212,0.392),(5.332,7.596));
( (-0.452,0.46),(5.296,7.432));
( (0.472,0.062),(6.17,7.602));
( (0.484,0.392),(5.956,7.432));
( (0.316,0.152),(6.32,7.872));
( (-0.14,0.392),(5.504,7.788));
( (1.4,0.4),(3.6898,4.6));
( (0.932,-1.144),(3.67917,4.59076));
( (0.514,0.628),(6.622,6.372));
( (1.476,1.616),(7.524,4.384));
( (1.378,0.628),(7.486,6.372));
( (1.412,0.410484),(5.684,7.848));
( (0.424,-2.716),(10.704,7.704));
( (-0.756,0.392),(6.552,7.608));
( (-0.436,0.392),(7.188,7.608));
( (-0.164,0.676),(8.028,7.848));
( (-0.436,0.392),(7.732,7.608));
( (-0.416,0.392),(6.968,7.608));
( (-0.38,0.392),(6.956,7.608));
( (0.112,0.104),(8.74,7.848));
( (-0.28,0.374),(9.352,7.626));
( (-0.436,0.374),(4.16,7.626));
( (-0.876,0.332),(5.34,7.608));
( (-0.328,0.392),(8.276,7.608));
( (-0.436,0.392),(6.608,7.608));
( (-0.22,0.392),(10.04,7.608));
( (-0.16,0.248),(8.74,7.608));
( (0.256,-0.00399998),(8.176,8.124));
( (-0.544,0.392),(7.02,7.608));
( (0.16,-2.684),(9.02,7.944));
( (-0.472,0.392),(7.008,7.608));
( (0.224,0.212),(5.356,7.728));
( (0.06,0.392),(6.9,7.704));
( (0.488,0.14),(8.54,7.608));
( (0.58,0.392),(7.96,7.608));
( (0.886,0.374),(10.39,7.626));
( (-0.104,0.392),(8.032,7.608));
( (0.444,0.374),(7.116,7.626));
( (-0.272,0.296),(6.928,7.704));
( (0.0440001,-1.656),(4.472,7.656));
( (-0.428,0.392),(2.572,7.596));
( (-0.138,-1.656),(4.326,7.656));
( (-0.332,2.542),(5.704,7.414));
( (-0.108,-3.276),(6.12,-2.724));
( (1.268,5.408),(3.068,8.084));
( (0.352,0.484),(5.992,4.884));
( (0.52,0.356),(5.636,7.626));
( (0.292,0.212),(5.54,4.68));
( (0.388,0.508),(6.488,7.608));
( (0.352,0.532),(4.66,4.656));
( (-1.624,-2.74),(5.3,7.632));
( (-0.576,-2.752),(5.996,4.836));
( (0.224,0.272),(5.768,7.608));
( (0.602,0.254),(3.47972,7.6));
( (-1.606,-2.716),(3.33808,7.6));
( (0.182,0.29),(5.51,7.638));
( (0.38,0.254),(3.416,7.638));
( (0.584,0.272),(7.936,5.74));
( (0.392,0.272),(5.876,5.74));
( (0.436,0.236),(5.636,6.016));
( (-0.424,-2.608),(5.612,4.704));
( (0.448,-2.608),(5.804,4.872));
( (0.392,0.392),(4.988,4.66));
( (0.416,0.236),(4.2,4.74));
( (0.38,0.272),(3.584,6.144));
( (0.596,0.242),(5.96,4.638));
( (-0.084,0.38),(5.504,4.632));
( (0.156,0.392),(7.6,5.716));
( (-0.168,0.4),(5.796,4.48));
( (-0.476,-2.552),(4.836,4.576));
( (-0.14,0.64),(4.396,4.36));
( (1.176,-1.728),(5.328,7.704));
( (-0.324,-2.256),(2.952,8.04));
( (-0.432,-1.728),(3.972,7.704));
( (0.476,2.474),(6.524,4.526));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.456,-2.662),(3.6,5.6));
( (0.43,-1.336),(5.57,6.036));
( (0.248,0.284),(6.516,7.764));
( (-2.372,0.38),(3.796,7.608));
( (0.468,0.392),(7.62,7.608));
( (-0.096,-2.716),(5.892,8.728));
( (0.028,-1.644),(5.852,8.692));
( (-0.14,0.836),(6.164,7.176));
( (0.824,4.586),(2.684,7.418));
( (2.10199,5.408),(6.068,8.084));
( (0.473464,0.436),(5.328,4.924));
( (0.484,-0.0639999),(3.34,4.424));
( (0.72,0.0640001),(3.504,4.684));
( (-1.696,-2.728),(5.804,7.632));
( (-1.696,-2.74),(6.416,7.716));
( (0.0,0.0),(3.0,0.0));
( (-0.036,2.712),(6.012,3.288));
( (1.18,-1.104),(6.112,9.036));
( (0.0320001,-0.832),(5.968,8.94));
( (1.256,2.256),(2.744,3.744));
( (0.0,0.0),(3.0,0.0));
( (1.206,-2.742),(6.202,7.71));
( (0.488,2.5),(3.5,5.5));
( (0.956,-1.168),(2.756,1.508));
( (0.944,-1.228),(4.9141,1.448));
( (0.944,4.772),(4.9141,7.448));
( (0.726439,0.0640001),(5.492,4.684));
( (0.4,0.4),(9.5994,1.6));
( (0.46,-0.196),(11.734,7.944));
( (0.0,0.0),(3.0,0.0));
( (0.304,-2.86),(4.612,5.612));
( (0.0,0.0),(3.0,0.0));
( (1.472,5.452),(3.62,7.552));
( (1.87,5.478),(4.63,7.686));
( (0.894,5.26),(4.23,7.348));
( (1.332,6.244),(4.68,7.696));
( (1.44,6.628),(4.56,7.348));
( (1.32,6.484),(4.704,8.236));
( (1.352,6.328),(2.672,7.648));
( (1.4,6.4),(4.6,7.6));
( (0.0,0.0),(3.0,0.0));
( (3.308,6.308),(5.692,8.692));
( (-0.52,-2.764),(2.516,0.608));
( (0.0,0.0),(3.0,0.0));
( (0.676,5.992),(4.464,8.668));
( (-0.468,-2.462),(2.184,0.0219999));
( (1.734,5.676),(5.142,7.764));
( (-0.78,2.712),(11.34,3.288));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.948,0.392),(10.95,7.608));
( (0.0,0.0),(3.0,0.0));
( (0.616,3.308),(3.558,7.764));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.172,0.392),(6.62,7.608));
( (0.052,-0.88),(8.936,8.436));
( (0.154,-0.034),(10.95,7.71));
( (0.664,3.308),(3.42,7.848));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.436,0.526),(7.63,5.686));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.632,0.254),(3.02,4.638));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.446,0.254),(3.614,7.638));
( (0.436,-1.048),(5.816,6.964));
( (0.178,0.338),(7.594,4.704));
( (-2.524,-2.908),(5.612,7.74));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0))

|]};;


let Times_BoldItalic =
{Name="Times-BoldItalic"; Width=12.0; Height=12.0;
Descr=[|3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
4.66791;
6.65991;
6.0;
6.0;
9.99591;
9.336;
3.99591;
3.99591;
3.99591;
6.0;
6.8399;
3.0;
3.99591;
3.0;
3.336;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
3.99591;
3.99591;
6.8399;
6.8399;
6.8399;
6.0;
9.98383;
8.00391;
8.00391;
8.00391;
8.66382;
8.00391;
8.00391;
8.66382;
9.336;
4.66791;
6.0;
8.00391;
7.33191;
10.6679;
8.66382;
8.66382;
7.33191;
8.66382;
8.00391;
6.672;
7.33191;
8.66382;
8.00391;
10.6679;
8.00391;
7.33191;
7.33191;
3.99591;
3.336;
3.99591;
6.8399;
6.0;
3.99591;
6.0;
6.0;
5.32782;
6.0;
5.32782;
3.99591;
6.0;
6.672;
3.336;
3.336;
6.0;
3.336;
9.336;
6.672;
6.0;
6.0;
6.0;
4.66791;
4.66791;
3.336;
6.672;
5.32782;
8.00391;
6.0;
5.32782;
4.66791;
4.1759;
2.63983;
4.1759;
6.8399;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
4.66791;
6.0;
6.0;
2.00391;
6.0;
6.0;
6.0;
6.0;
3.336;
6.0;
6.0;
3.99591;
3.99591;
6.672;
6.672;
3.0;
6.0;
6.0;
6.0;
3.0;
3.0;
6.0;
4.19989;
3.99591;
6.0;
6.0;
6.0;
12.0;
12.0;
3.0;
6.0;
3.0;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.0;
3.99591;
3.99591;
3.99591;
12.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
11.3278;
3.0;
3.19189;
3.0;
3.0;
3.0;
3.0;
7.33191;
8.66382;
11.3278;
3.59985;
3.0;
3.0;
3.0;
3.0;
3.0;
8.66382;
3.0;
3.0;
3.0;
3.336;
3.0;
3.0;
3.336;
6.0;
8.66382;
6.0;
3.0;
3.0;
3.0;
3.0
|];
Descr_bbox=[|( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(0.0,0.0));
( (0.618,0.642),(4.35,7.35));
( (1.606,4.562),(6.52806,8.534));
( (0.048,0.26),(5.952,7.74));
( (0.236,-0.952),(5.422,8.008));
( (0.304,0.26),(9.698,7.908));
( (0.714,0.52),(9.172,7.704));
( (1.264,3.616),(3.688,7.372));
( (0.448,-1.74),(4.192,7.74));
( (-0.186,-1.74),(3.558,7.74));
( (0.654,2.408),(5.382,7.592));
( (-0.024,0.26),(6.024,6.0));
( (0.0,-1.74),(2.424,1.252));
( (0.404,2.31),(3.596,3.69));
( (0.618,0.624),(2.382,2.376));
( (-0.132,0.26),(3.468,7.74));
( (0.388,0.302),(5.612,7.674));
( (0.06,0.35),(4.98,7.42));
( (-0.33,0.34),(5.286,7.534));
( (-0.258,0.26),(5.262,7.42));
( (-0.42,0.26),(5.736,7.74));
( (-0.398,0.266),(5.518,7.648));
( (0.34,0.188),(6.518,7.74));
( (0.612,0.26),(6.228,7.66));
( (0.418,0.32),(5.558,7.698));
( (-0.512,0.35),(5.666,7.692));
( (0.618,0.197231),(3.486,4.376));
( (0.0460001,-2.378),(3.382,4.53894));
( (0.75,0.43),(6.858,6.57));
( (0.476,1.46),(6.524,4.54));
( (0.142,0.26),(6.25,6.57));
( (0.618,0.624),(5.256,7.686));
( (0.214,-2.352),(9.914,8.414));
( (-0.658,0.35),(7.306,7.74));
( (-0.328,0.314),(7.376,7.71));
( (0.588,0.682),(8.244,7.722));
( (-0.312,0.296),(8.376,7.686));
( (-0.324,0.29),(7.752,7.686));
( (-0.252,0.35),(7.74,7.686));
( (0.576,0.284),(8.704,7.71));
( (-0.0459998,0.35),(9.27,7.65));
( (0.0620002,0.26),(5.27,7.74));
( (-0.268,-0.722),(6.264,7.65));
( (-0.00999976,0.35),(8.254,7.65));
( (-0.0459998,0.308),(7.226,7.65));
( (-0.73,0.206),(11.034,7.65));
( (-0.736,0.134),(8.742,7.65));
( (0.654,0.296),(8.364,7.698));
( (-0.746,0.35),(7.544,7.71));
( (0.654,-2.49),(8.364,7.698));
( (-0.258,0.35),(7.394,7.686));
( (0.0920001,0.296),(6.398,7.71));
( (0.538,0.35),(7.654,7.71));
( (0.872,0.67),(8.736,7.65));
( (0.73,0.26),(8.64,7.65));
( (0.35,0.26),(10.61,7.65));
( (0.212,0.35),(8.706,7.65));
( (0.32,0.35),(7.73,7.65));
( (-0.012,0.29),(7.128,7.716));
( (-0.084,-1.71),(4.656,7.71));
( (0.012,0.26),(5.58,7.74));
( (-0.78,-1.71),(3.96,7.71));
( (0.488,2.582),(6.512,7.418));
( (0.5,-1.728),(6.5,-1.272));
( (1.294,3.628),(3.718,7.384));
( (0.268,0.568),(5.92,4.258));
( (0.254,0.272),(5.738,8.342));
( (0.744,0.622),(4.75,4.698));
( (0.262,0.574),(6.646,8.342));
( (0.732,0.622),(4.57,4.716));
( (-1.66,-2.674),(5.108,7.686));
( (-0.722,-2.716),(6.428,4.692));
( (0.144,0.044),(6.216,8.342));
( (-0.0139999,0.586),(3.298,7.1693));
( (-1.564,-2.274),(3.304,7.16463));
( (0.12,0.104),(6.132,8.342));
( (0.034,0.586),(3.694,8.342));
( (0.192,0.104),(9.048,4.444));
( (0.288,0.104),(6.216,4.444));
( (0.298,0.026),(5.714,4.674));
( (-0.47,-2.65),(6.25,4.432));
( (0.262,-2.65),(5.842,4.306));
( (0.108,0.26),(4.98,4.324));
( (0.65,0.32),(4.206,4.71));
( (-0.122,0.574),(3.408,6.74));
( (0.00400003,0.568),(5.938,4.324));
( (0.458,0.26),(5.126,4.324));
( (0.396,0.26),(7.456,4.324));
( (-0.06,0.322),(5.976,4.324));
( (-1.094,-2.768),(4.702,4.33));
( (-0.312,-0.316),(4.728,4.552));
( (0.252,-1.824),(4.56,8.028));
( (0.514,0.26),(1.486,7.74));
( (-0.372,-2.028),(3.936,7.776));
( (0.476,2.33),(6.524,4.67));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.338,-2.344),(3.382,4.364));
( (0.672,-0.968),(5.6,6.042));
( (-0.674,0.444),(5.678,7.722));
( (-1.932,0.26),(3.924,7.74));
( (-0.6,0.438),(6.334,7.74));
( (-0.696,-1.662),(6.918,8.674));
( (0.0140001,-1.632),(5.696,7.632));
( (0.382,1.418),(5.618,7.606));
( (1.51,4.562),(3.634,8.534));
( (0.279337,3.628),(5.724,7.384));
( (0.262,0.648),(5.58354,5.268));
( (0.262,0.648),(3.514,5.268));
( (0.492,0.732),(3.744,5.352));
( (-1.57,-2.268),(6.762,7.716));
( (-1.698,-2.722),(7.038,8.674));
( (0.0,0.0),(3.0,0.0));
( (0.368,2.46),(6.632,3.54));
( (1.08,-1.752),(5.868,7.74));
( (0.132,-1.896),(5.844,7.812));
( (0.606,2.606),(2.394,4.394));
( (0.0,0.0),(3.0,0.0));
( (0.406,-2.02),(7.556,8.432));
( (0.488,2.5),(3.5,5.5));
( (1.288,-2.378),(3.712,1.378));
( (-0.712,-2.378),(4.72452,1.378));
( (0.318,3.616),(5.73434,7.372));
( (0.41827,0.732),(5.744,5.352));
( (0.618006,0.624),(10.382,2.376));
( (0.424,-0.04),(11.65,8.766));
( (0.0,0.0),(3.0,0.0));
( (0.75,-2.698),(5.382,5.382));
( (0.0,0.0),(3.0,0.0));
( (1.74,6.426),(4.26,8.574));
( (1.578,6.426),(4.518,8.574));
( (0.556,6.468),(4.444,8.532));
( (0.37,6.292),(4.63,7.708));
( (1.466,6.586),(5.534,7.414));
( (1.466,5.54),(5.378,7.46));
( (1.732,6.726),(3.268,8.274));
( (0.873953,6.726),(5.26578,8.274));
( (0.0,0.0),(3.0,0.0));
( (1.706,5.712),(4.282,7.282));
( (0.75,-2.746),(3.618,0.532));
( (0.0,0.0),(3.0,0.0));
( (0.7,6.734),(4.428,9.338));
( (-0.834,-2.678),(2.214,0.0579999));
( (1.532,6.468),(5.468,8.532));
( (0.332,2.46),(12.668,3.54));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.658,0.296),(11.006,7.692));
( (0.0,0.0),(3.0,0.0));
( (-0.288,3.676),(3.492,7.65));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.0459998,0.308),(7.226,7.65));
( (0.654,-0.976),(8.364,8.634));
( (0.666,0.206),(11.622,7.788));
( (0.376,3.676),(3.462,7.608));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (-0.25,0.574),(8.528,4.258));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.274,0.586),(3.07,4.324));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.094,0.574),(3.862,8.342));
( (0.298,-0.982),(5.714,5.85));
( (0.304,0.32),(8.516,4.686));
( (-1.588,-2.686),(5.66,8.68));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0))

|]};;


let Helvetica =
{Name="Helvetica"; Width=12.18; Height=12.0;
Descr=[|3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
4.25995;
6.672;
6.672;
10.6679;
8.00391;
2.66382;
3.99591;
3.99591;
4.66791;
7.008;
3.336;
3.99591;
3.336;
3.336;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
3.336;
3.336;
7.008;
7.008;
7.008;
6.672;
12.18;
8.00391;
8.00391;
8.66382;
8.66382;
8.00391;
7.33191;
9.336;
8.66382;
3.336;
6.0;
8.00391;
6.672;
9.99591;
8.66382;
9.336;
8.00391;
9.336;
8.66382;
8.00391;
7.33191;
8.66382;
8.00391;
11.3278;
8.00391;
8.00391;
7.33191;
3.336;
3.336;
3.336;
5.62793;
6.672;
2.66382;
6.672;
6.672;
6.0;
6.672;
6.672;
3.336;
6.672;
6.672;
2.66382;
2.66382;
6.0;
2.66382;
9.99591;
6.672;
6.672;
6.672;
6.672;
3.99591;
6.0;
3.336;
6.672;
6.0;
8.66382;
6.0;
6.0;
6.0;
4.008;
3.11993;
4.008;
7.008;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
6.672;
6.672;
2.00391;
6.672;
6.672;
6.672;
6.672;
2.29193;
3.99591;
6.672;
3.99591;
3.99591;
6.0;
6.0;
3.336;
6.672;
6.672;
6.672;
3.336;
3.336;
6.44385;
4.19989;
2.66382;
3.99591;
3.99591;
6.672;
12.0;
12.0;
3.336;
7.33191;
3.336;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.99591;
12.0;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
12.0;
3.336;
4.43994;
3.336;
3.336;
3.336;
3.336;
6.672;
9.336;
12.0;
4.37988;
3.336;
3.336;
3.336;
3.336;
3.336;
10.6679;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
2.66382;
7.33191;
11.3278;
7.33191;
3.336;
3.336;
3.336;
3.336
|];
Descr_bbox=[|( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.996,-0.0933972),(2.004,8.998));
( (0.936,6.024),(4.03681,8.976));
( (0.288,0.00200002),(6.67,7.998));
( (0.864,-1.144),(6.046,9.568));
( (0.074,0.074),(9.92,8.196));
( (0.942,-0.286),(7.748,9.136));
( (0.936,5.254),(2.064,8.118));
( (0.996,-2.556),(3.612,8.748));
( (0.382,-2.556),(2.998,8.748));
( (0.688,5.424),(4.324,8.88));
( (0.596,-0.404),(6.404,5.404));
( (0.864,-1.924),(2.124,1.124));
( (0.552,3.062),(3.408,3.938));
( (0.876,-0.124),(2.124,1.124));
( (-0.384,0.00200002),(3.12,7.998));
( (0.978,0.00800002),(6.016,8.016));
( (1.064,0.00200002),(4.004,8.998));
( (0.792,-0.00399998),(6.334,9.04));
( (-0.00999998,0.00800002),(6.076,8.974));
( (0.336,0.00200002),(6.24,8.998));
( (0.328,-0.016),(6.136,8.028));
( (0.972,0.026),(6.04,8.998));
( (0.832,0.00200002),(6.52,9.004));
( (-0.088,0.00200002),(6.082,8.968));
( (-0.034,-0.022),(6.004,8.992));
( (0.876,-0.124),(2.124,6.13042));
( (0.864,-1.8),(2.124,6.11693));
( (0.906,-0.41),(6.774,5.398));
( (0.6,1.08),(6.408,3.92));
( (0.22,-0.404),(6.088,5.404));
( (0.954,-0.124),(6.268,9.148));
( (-0.226,-2.166),(11.022,9.04));
( (0.624,-0.00399998),(8.256,9.004));
( (0.936,0.00200002),(7.136,8.998));
( (0.906,-0.00399998),(8.082,9.004));
( (0.936,0.00200002),(8.172,8.998));
( (0.936,0.00200002),(7.212,8.998));
( (0.936,0.00200002),(6.804,8.998));
( (0.918,0.00200002),(9.004,9.04));
( (0.936,0.00200002),(8.064,8.998));
( (0.936,0.00200002),(2.064,8.998));
( (-0.064,-0.082),(5.064,8.998));
( (0.936,0.00200002),(7.884,8.998));
( (0.936,0.00200002),(6.372,8.998));
( (0.924,0.00200002),(10.076,8.998));
( (0.936,0.00200002),(8.064,8.998));
( (0.918,-0.00399998),(9.082,9.004));
( (0.936,0.00200002),(7.298,9.082));
( (0.918,-0.436),(9.082,9.004));
( (0.936,0.00200002),(8.394,8.998));
( (0.666,-0.064),(7.166,8.974));
( (0.0560002,0.00200002),(6.92,8.998));
( (0.936,0.02),(8.064,8.998));
( (0.798,0.00200002),(8.178,8.998));
( (0.674,0.00200002),(11.35,8.998));
( (0.72,0.00200002),(8.244,8.998));
( (0.588,0.00200002),(8.364,8.998));
( (0.336,0.00200002),(6.996,8.998));
( (0.99,-2.95),(3.222,8.95));
( (-0.096,0.00200002),(3.408,8.998));
( (-0.222,-2.95),(2.01,8.95));
( (0.208,3.498),(4.78,8.058));
( (-0.264,-1.8),(6.936,-1.2));
( (0.948,5.87),(2.064,8.758));
( (0.9,-0.00399998),(6.73,5.962));
( (0.996,0.02),(6.148,8.998));
( (-0.07,-0.00999998),(6.004,5.974));
( (-0.16,0.026),(6.004,8.998));
( (0.93,0.062),(6.058,5.974));
( (0.144,0.00200002),(3.024,8.986));
( (-0.088,-2.98),(6.004,6.088));
( (0.996,0.00200002),(6.028,8.998));
( (0.996,0.00200002),(2.004,9.124));
( (-0.048,-2.968),(2.004,8.9418));
( (0.996,0.00200002),(6.324,8.998));
( (0.996,0.00200002),(2.004,8.998));
( (0.996,0.00200002),(10.004,5.968));
( (0.996,0.00200002),(6.004,5.968));
( (-0.022,-0.00399998),(6.016,6.004));
( (0.996,-2.74),(6.148,5.974));
( (-0.148,-2.74),(6.004,5.974));
( (0.996,0.00200002),(4.02,6.028));
( (0.744,0.038),(6.07,5.968));
( (0.12,-0.016),(3.0,7.74));
( (0.996,0.026),(6.004,5.998));
( (-0.26,-0.172),(5.452,5.998));
( (0.13,0.00200002),(8.93,5.998));
( (-0.272,0.00200002),(5.2,5.998));
( (-0.104,-3.004),(5.392,5.998));
( (0.372,0.00200002),(5.484,5.998));
( (0.108,-2.896),(2.904,8.896));
( (1.14,-2.58),(1.86,8.748));
( (0.09,-2.902),(2.886,8.896));
( (1.17,2.912),(5.854,5.372));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.996,-2.998),(2.004,6.124));
( (0.774,-1.138),(5.98,6.976));
( (0.588,-0.562),(6.292,9.19));
( (-2.088,0.00200002),(4.032,7.998));
( (0.296,0.00200002),(6.704,8.072));
( (0.0920002,-3.118),(6.464,9.064));
( (0.966,-3.082),(6.094,9.064));
( (0.762,1.69),(6.364,6.376));
( (0.936,6.024),(2.064,8.976));
( (0.978279,5.87),(4.064,8.858));
( (0.908683,1.496),(5.03,5.48));
( (1.2,1.538),(3.024,5.426));
( (0.94,1.544),(2.788,5.432));
( (0.144,0.00200002),(5.004,8.962));
( (0.144,0.00200002),(5.004,8.962));
( (0.0,0.0),(3.336,0.0));
( (-0.06,3.062),(6.732,3.938));
( (0.608,-2.174),(6.308,8.482));
( (0.602,-2.53),(6.302,8.482));
( (0.756,3.756),(2.244,5.244));
( (0.0,0.0),(3.336,0.0));
( (0.482,-1.994),(6.586,8.89));
( (0.988,3.0),(4.0,6.0));
( (0.936,-1.746),(2.064,1.118));
( (0.936,-1.74),(4.064,1.118));
( (0.936579,5.30825),(4.03681,8.09225));
( (0.94,1.502),(5.707,5.486));
( (1.876,-0.124),(11.1234,1.124));
( (0.134,0.134),(11.86,8.992));
( (0.0,0.0),(3.336,0.0));
( (0.732,-3.166),(6.13,6.124));
( (0.0,0.0),(3.336,0.0));
( (0.394,7.104),(2.902,8.88));
( (1.11,7.104),(3.618,8.88));
( (-0.228,7.078),(3.216,8.878));
( (0.224,6.822),(3.764,8.346));
( (0.336,7.062),(3.624,7.938));
( (0.272,7.026),(3.704,8.706));
( (1.876,6.876),(3.124,8.124));
( (-0.052,6.882),(3.8109,8.118));
( (0.0,0.0),(3.336,0.0));
( (1.278,7.278),(2.716,8.716));
( (-0.0259999,-2.824),(3.01,0.028));
( (0.0,0.0),(3.336,0.0));
( (-0.878,6.966),(4.606,8.742));
( (0.972,-2.01),(3.564,0.522));
( (-0.222,7.146),(3.222,8.946));
( (-0.108,3.062),(12.012,3.938));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.476,0.00200002),(11.744,8.998));
( (0.0,0.0),(3.336,0.0));
( (0.14,3.188),(4.244,8.956));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (-0.216,0.00200002),(6.408,8.998));
( (0.81,-0.00399998),(9.082,9.01));
( (0.798,-0.046),(11.15,9.124));
( (0.188,3.188),(3.806,8.8));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (-0.064,-0.00399998),(10.1,7.1));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.996,0.00200002),(2.004,5.998));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.228,0.00200002),(2.772,8.998));
( (-0.142,-0.094),(6.34,7.076));
( (0.66,-0.106),(11.094,6.154));
( (1.912,-0.07),(7.046,9.208));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0))

|]};;


let Helvetica_Bold  =
{Name="Helvetica-Bold"; Width=12.0; Height=12.0;
Descr=[|3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
5.68799;
6.672;
6.672;
10.6679;
8.66382;
3.336;
3.99591;
3.99591;
4.66791;
7.008;
3.336;
3.99591;
3.336;
3.336;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
3.99591;
3.99591;
7.008;
7.008;
7.008;
7.33191;
11.6999;
8.66382;
8.66382;
8.66382;
8.66382;
8.00391;
7.33191;
9.336;
8.66382;
3.336;
6.672;
8.66382;
7.33191;
9.99591;
8.66382;
9.336;
8.00391;
9.336;
8.66382;
8.00391;
7.33191;
8.66382;
8.00391;
11.3278;
8.00391;
8.00391;
7.33191;
3.99591;
3.336;
3.99591;
7.008;
6.672;
3.336;
6.672;
7.33191;
6.672;
7.33191;
6.672;
3.99591;
7.33191;
7.33191;
3.336;
3.336;
6.672;
3.336;
10.6679;
7.33191;
7.33191;
7.33191;
7.33191;
4.66791;
6.672;
3.99591;
7.33191;
6.672;
9.336;
6.672;
6.672;
6.0;
4.66791;
3.35999;
4.66791;
7.008;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
6.672;
6.672;
2.00391;
6.672;
6.672;
6.672;
6.672;
2.8559;
6.0;
6.672;
3.99591;
3.99591;
7.33191;
7.33191;
3.336;
6.672;
6.672;
6.672;
3.336;
3.336;
6.672;
4.19989;
3.336;
6.0;
6.0;
6.672;
12.0;
12.0;
3.336;
7.33191;
3.336;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.99591;
12.0;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
12.0;
3.336;
4.43994;
3.336;
3.336;
3.336;
3.336;
7.33191;
9.336;
12.0;
4.37988;
3.336;
3.336;
3.336;
3.336;
3.336;
10.6679;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
7.33191;
11.3278;
7.33191;
3.336;
3.336;
3.336;
3.336
|];
Descr_bbox=[|( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.1,0.108994),(2.9,8.75));
( (0.172,5.946),(4.77888,9.054));
( (0.162,-0.254),(6.628,8.608));
( (-0.00799997,-1.396),(6.822,8.76));
( (-0.106,-0.166),(10.1,8.148));
( (-0.08,-0.238),(7.838,9.676));
( (1.19,5.63),(2.81,8.75));
( (0.232,-2.424),(3.388,8.748));
( (0.6,-2.424),(3.756,8.748));
( (0.496,4.62),(4.492,8.76));
( (0.596,-0.404),(6.404,5.404));
( (1.1,-1.964),(2.924,1.876));
( (0.312,2.184),(3.576,3.816));
( (1.1,0.124),(2.9,1.876));
( (0.11,0.25),(3.386,8.75));
( (0.124,0.196),(5.876,8.804));
( (1.12,0.26),(4.84,8.814));
( (0.064,0.238),(6.002,8.34));
( (0.184,-0.178),(5.912,9.208));
( (0.752,0.25),(6.728,8.858));
( (0.142,-0.292),(6.218,8.756));
( (-0.044,-0.274),(6.056,9.382));
( (0.006,0.26),(5.994,8.756));
( (-0.164,-0.22),(6.278,9.214));
( (0.142,-0.16),(6.254,9.382));
( (1.1,0.0266667),(2.9,5.876));
( (1.1,-1.964),(2.924,5.876));
( (0.878,0.09),(6.746,5.898));
( (0.6,0.78),(6.408,5.22));
( (0.182,-0.404),(6.05,5.404));
( (1.112,0.124),(7.152,9.152));
( (-0.094,-2.088),(11.19,9.16));
( (-0.0919999,0.26),(8.032,9.062));
( (1.1,0.25),(8.056,8.75));
( (0.124,0.166),(7.858,8.756));
( (1.1,0.25),(7.906,8.75));
( (1.1,0.25),(7.64,8.75));
( (1.1,0.25),(7.244,8.75));
( (-0.596,-0.328),(8.756,9.244));
( (0.832,0.26),(7.9,8.74));
( (1.1,0.26),(2.9,8.74));
( (0.1,0.196),(5.9,8.74));
( (1.1,0.26),(8.816,8.74));
( (1.1,0.25),(7.088,8.74));
( (1.1,0.26),(8.9,8.74));
( (1.1,0.26),(7.9,8.74));
( (0.13,0.214),(8.864,8.786));
( (1.1,0.26),(7.99,8.75));
( (0.13,-0.158),(8.864,8.786));
( (1.1,0.26),(7.984,8.75));
( (-0.00799997,-0.238),(8.326,9.214));
( (0.448,0.26),(7.456,8.75));
( (1.1,0.22),(7.9,8.74));
( (0.262,0.26),(7.738,8.74));
( (0.156,0.26),(11.184,8.74));
( (0.264,0.26),(7.836,8.74));
( (0.324,0.26),(7.8,8.74));
( (0.36,0.25),(6.936,8.75));
( (1.214,-2.124),(4.118,9.1));
( (0.344,0.25),(3.956,8.75));
( (-0.118,-2.124),(2.786,9.1));
( (0.246,3.686),(5.778,8.786));
( (-0.264,-1.92),(6.936,-1.08));
( (1.19,5.25),(2.81,8.37));
( (0.106,-0.34),(6.17,7.106));
( (1.16,-0.256),(7.098,8.74));
( (0.058,-0.268),(5.822,7.268));
( (0.118,-0.262),(6.84,8.74));
( (0.13,-0.19),(5.918,7.202));
( (0.248,0.26),(3.836,9.124));
( (-0.122,-3.142),(6.774,6.822));
( (1.16,0.26),(6.84,8.74));
( (1.16,0.248),(2.84,8.78887));
( (0.368,-2.066),(2.84,8.81931));
( (1.16,0.26),(7.028,8.74));
( (1.16,0.126),(2.84,8.874));
( (1.16,0.26),(10.84,7.382));
( (1.16,0.26),(6.84,7.184));
( (0.148,-0.22),(6.846,7.22));
( (1.16,-2.74),(7.206,7.304));
( (-0.212,-2.74),(6.84,6.822));
( (1.16,0.26),(4.844,6.942));
( (-0.056,-0.142),(5.9,7.154));
( (0.332,-0.16),(3.776,7.74));
( (1.16,-0.244),(6.84,6.74));
( (-0.126,0.106),(6.138,6.74));
( (0.06,0.26),(9.192,6.74));
( (0.192,0.26),(6.42,6.74));
( (0.108,-2.178),(6.456,6.74));
( (0.252,-0.19),(5.616,7.19));
( (0.826,-2.088),(4.186,9.088));
( (1.02,-2.424),(1.98,8.748));
( (0.814,-2.088),(4.174,9.082));
( (1.074,1.798),(5.98,4.214));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.1,-1.75),(2.9,6.876));
( (0.00400003,-1.408),(5.792,8.186));
( (0.058,0.00400003),(5.966,8.382));
( (-2.04,0.25),(4.08,8.75));
( (0.17,0.25),(6.734,8.096));
( (0.252,-2.472),(6.42,9.274));
( (0.684,-2.406),(6.286,9.178));
( (0.36,1.354),(6.664,7.658));
( (0.172,5.94),(1.828,9.06));
( (0.974714,5.25),(4.81,8.37));
( (1.098,0.492),(6.02237,5.448));
( (1.122,0.564),(3.126,5.4));
( (0.874,0.576),(2.878,5.412));
( (0.248,0.25),(6.84,9.124));
( (0.248,0.25),(6.84,9.124));
( (0.0,0.0),(3.336,0.0));
( (-0.108,2.87),(6.684,4.13));
( (0.012,-1.952),(5.916,8.884));
( (0.012,-1.932),(5.916,8.884));
( (0.756,3.756),(2.244,5.244));
( (0.0,0.0),(3.336,0.0));
( (0.464,-2.156),(6.844,8.932));
( (0.982,2.0),(3.994,5.0));
( (1.19,-1.37),(2.81,1.75));
( (1.19,-1.814),(4.81,1.846));
( (1.19,5.63),(5.0381,8.75));
( (0.922,1.022),(5.59009,5.954));
( (1.1,0.124),(10.8991,1.876));
( (0.014,0.014),(11.98,8.98));
( (0.0,0.0),(3.336,0.0));
( (-0.152,-2.176),(6.888,6.81));
( (0.0,0.0),(3.336,0.0));
( (0.586,7.14),(2.938,8.94));
( (1.056,7.14),(3.408,8.94));
( (0.556,7.072),(4.372,8.836));
( (0.224,6.846),(3.764,9.07));
( (0.192,7.972),(3.78,9.028));
( (0.302,7.008),(3.71,8.748));
( (1.84,7.768),(3.16,9.232));
( (-0.16,7.768),(3.9329,9.232));
( (0.0,0.0),(3.336,0.0));
( (1.254,7.254),(2.74,8.74));
( (0.818,-2.95),(4.058,-0.00200002));
( (0.0,0.0),(3.336,0.0));
( (-0.944,7.14),(4.408,8.94));
( (0.912,-2.076),(3.624,0.804));
( (0.562,7.17),(4.378,8.934));
( (-0.084,2.87),(12.036,4.13));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.25),(11.58,8.75));
( (0.0,0.0),(3.336,0.0));
( (-0.034,3.02),(4.196,8.902));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0200001,0.25),(7.184,8.75));
( (0.058,0.028),(9.056,8.894));
( (-0.266,-0.304),(12.052,8.774));
( (-0.00999998,3.02),(4.004,8.932));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.052,-0.304),(9.936,6.34));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.16,0.25),(2.84,6.75));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.494,0.25),(3.518,8.75));
( (-0.164,-0.394),(7.17,6.304));
( (0.058,-0.352),(10.87,6.22));
( (1.16,-0.562),(7.002,9.304));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0))

|]};;


let Helvetica_Oblique =
{Name="Helvetica-Oblique"; Width=12.0; Height=12.0;
Descr=[|3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
4.25995;
6.672;
6.672;
10.6679;
8.00391;
2.66382;
3.99591;
3.99591;
4.66791;
7.008;
3.336;
3.99591;
3.336;
3.336;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
3.336;
3.336;
7.008;
7.008;
7.008;
6.672;
12.18;
8.00391;
8.00391;
8.66382;
8.66382;
8.00391;
7.33191;
9.336;
8.66382;
3.336;
6.0;
8.00391;
6.672;
9.99591;
8.66382;
9.336;
8.00391;
9.336;
8.66382;
8.00391;
7.33191;
8.66382;
8.00391;
11.3278;
8.00391;
8.00391;
7.33191;
3.336;
3.336;
3.336;
5.62793;
6.672;
2.66382;
6.672;
6.672;
6.0;
6.672;
6.672;
3.336;
6.672;
6.672;
2.66382;
2.66382;
6.0;
2.66382;
9.99591;
6.672;
6.672;
6.672;
6.672;
3.99591;
6.0;
3.336;
6.672;
6.0;
8.66382;
6.0;
6.0;
6.0;
4.008;
3.11993;
4.008;
7.008;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
6.672;
6.672;
2.00391;
6.672;
6.672;
6.672;
6.672;
2.29193;
3.99591;
6.672;
3.99591;
3.99591;
6.0;
6.0;
3.336;
6.672;
6.672;
6.672;
3.336;
3.336;
6.44385;
4.19989;
2.66382;
3.99591;
3.99591;
6.672;
12.0;
12.0;
3.336;
7.33191;
3.336;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.99591;
12.0;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
12.0;
3.336;
4.43994;
3.336;
3.336;
3.336;
3.336;
6.672;
9.336;
12.0;
4.37988;
3.336;
3.336;
3.336;
3.336;
3.336;
10.6679;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
2.66382;
7.33191;
11.3278;
7.33191;
3.336;
3.336;
3.336;
3.336
|];
Descr_bbox=[|( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.976148,-0.0933972),(3.91659,8.998));
( (2.54044,6.024),(5.94472,8.976));
( (0.737836,0.00200002),(7.92827,7.998));
( (0.93967,-1.144),(7.34299,9.568));
( (1.12883,0.074),(10.5645,8.196));
( (1.32208,-0.286),(7.90358,9.136));
( (2.05277,5.254),(3.78954,8.118));
( (1.23066,-2.556),(5.47145,8.748));
( (-0.161296,-2.556),(4.07949,8.748));
( (2.23882,5.424),(5.86206,8.88));
( (1.03812,-0.404),(7.02467,5.404));
( (0.45504,-1.924),(2.36291,1.124));
( (1.20285,3.062),(4.24505,3.938));
( (0.849643,-0.124),(2.36291,1.124));
( (-0.383575,0.00200002),(4.82003,7.998));
( (1.53648,0.00800002),(7.16257,8.016));
( (2.41574,0.00200002),(5.91659,8.998));
( (0.79115,-0.00399998),(7.48043,9.04));
( (0.387613,0.00800002),(7.53805,8.974));
( (0.76175,0.00200002),(6.91659,8.998));
( (0.545448,-0.016),(7.35041,8.028));
( (1.40061,0.026),(7.31604,8.998));
( (1.92443,0.00200002),(8.43386,9.004));
( (0.370835,0.00200002),(7.51441,8.968));
( (0.494943,-0.022),(7.22415,8.992));
( (0.849643,-0.124),(3.42706,6.13042));
( (0.481397,-1.8),(3.4242,6.11693));
( (1.34684,-0.41),(7.92138,5.398));
( (0.829562,1.08),(7.24122,3.92));
( (0.134127,-0.404),(6.70867,5.404));
( (2.2704,-0.124),(8.09769,9.148));
( (0.449801,-2.166),(12.0376,9.04));
( (0.62315,-0.00399998),(8.25515,9.004));
( (0.936425,0.00200002),(8.18135,8.998));
( (1.60494,-0.00399998),(9.2331,9.004));
( (0.936425,0.00200002),(9.45306,8.998));
( (0.936425,0.00200002),(8.92059,8.998));
( (0.936425,0.00200002),(8.71659,8.998));
( (1.63566,0.00200002),(10.285,9.04));
( (0.936425,0.00200002),(9.97659,8.998));
( (0.936425,0.00200002),(3.97659,8.998));
( (0.262472,-0.082),(6.97659,8.998));
( (0.936425,0.00200002),(9.79659,8.998));
( (0.936425,0.00200002),(6.58752,8.998));
( (0.924425,0.00200002),(11.9886,8.998));
( (0.936425,0.00200002),(9.97659,8.998));
( (1.61694,-0.00399998),(10.2721,9.004));
( (0.936425,0.00200002),(8.68468,9.082));
( (1.61694,-0.436),(10.2721,9.004));
( (0.936425,0.00200002),(9.80902,8.998));
( (1.09185,-0.064),(8.41649,8.974));
( (1.75349,0.00200002),(8.83259,8.998));
( (1.31364,0.02),(9.97659,8.998));
( (2.71059,0.00200002),(10.0906,8.998));
( (2.58659,0.00200002),(13.2626,8.998));
( (0.720425,0.00200002),(10.0366,8.998));
( (2.50059,0.00200002),(10.2766,8.998));
( (0.336425,0.00200002),(8.89659,8.998));
( (0.362957,-2.95),(5.12439,8.95));
( (1.81659,0.00200002),(3.40843,8.998));
( (-0.849043,-2.95),(3.91239,8.95));
( (0.951524,3.498),(5.52352,8.058));
( (-0.646603,-1.8),(6.68093,-1.2));
( (2.19571,5.87),(3.92557,8.758));
( (1.06056,-0.00399998),(7.12255,5.962));
( (1.05892,0.02),(6.92668,8.998));
( (0.429619,-0.00999998),(6.89837,5.974));
( (0.39911,0.026),(7.91659,8.998));
( (1.46181,0.062),(6.9945,5.974));
( (0.996425,0.00200002),(4.91873,8.986));
( (-0.127206,-2.98),(7.25213,6.088));
( (0.996425,0.00200002),(7.04891,8.998));
( (0.996425,0.00200002),(3.94337,9.124));
( (-0.673768,-2.968),(3.90464,8.9418));
( (0.996425,0.00200002),(7.20295,8.998));
( (0.996425,0.00200002),(3.91659,8.998));
( (0.996425,0.00200002),(11.0715,5.968));
( (0.996425,0.00200002),(7.00414,5.968));
( (0.464779,-0.00399998),(6.80456,6.004));
( (0.413594,-2.74),(6.86202,5.974));
( (0.349773,-2.74),(7.23556,5.974));
( (0.996425,0.00200002),(5.30129,6.028));
( (0.853549,0.038),(6.73954,5.968));
( (1.13397,-0.016),(4.27104,7.74));
( (1.29852,0.026),(7.27892,5.998));
( (1.01492,-0.172),(6.72692,5.998));
( (1.40492,0.00200002),(10.2049,5.998));
( (-0.271575,0.00200002),(6.45092,5.998));
( (-0.322812,-3.004),(6.66692,5.998));
( (0.372425,0.00200002),(6.61492,5.998));
( (0.559036,-2.896),(4.79491,8.896));
( (0.591603,-2.58),(3.71945,8.748));
( (-0.52684,-2.902),(3.71804,8.896));
( (1.88844,2.912),(6.83052,5.372));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.358754,-2.998),(3.3057,6.124));
( (1.32174,-1.138),(6.84165,6.976));
( (0.853299,-0.562),(7.99607,9.19));
( (-2.08757,0.00200002),(5.73203,7.998));
( (1.38098,0.00200002),(8.41976,8.072));
( (-0.517188,-3.118),(8.3243,9.064));
( (1.01538,-3.082),(7.36375,9.064));
( (1.31971,1.69),(7.55092,6.376));
( (2.54044,6.024),(3.97191,8.976));
( (2.22599,5.87),(5.94683,8.858));
( (1.5404,1.496),(6.19481,5.48));
( (1.83299,1.538),(4.17733,5.426));
( (1.26819,1.544),(3.64673,5.432));
( (0.996425,0.00200002),(6.89618,8.962));
( (0.996425,0.00200002),(6.89618,8.962));
( (0.0,0.0),(3.336,0.0));
( (0.59085,3.062),(7.56905,3.938));
( (1.67121,-2.174),(7.58292,8.482));
( (0.674425,-2.53),(7.57692,8.482));
( (1.62578,3.756),(3.28723,5.244));
( (0.0,0.0),(3.336,0.0));
( (1.61153,-1.994),(8.47563,8.89));
( (1.77796,3.0),(5.1325,6.0));
( (0.564875,-1.746),(2.30164,1.118));
( (0.566151,-1.74),(4.30164,1.118));
( (2.06488,5.30825),(5.75687,8.09225));
( (1.25926,1.502),(6.5619,5.486));
( (1.84964,-0.124),(11.3623,1.124));
( (1.24873,0.134),(12.5054,8.992));
( (0.0,0.0),(3.336,0.0));
( (0.176376,-3.166),(5.99203,6.124));
( (0.0,0.0),(3.336,0.0));
( (2.28151,7.104),(4.412,8.88));
( (2.62,7.104),(5.50551,8.88));
( (1.27648,7.078),(4.72048,8.878));
( (1.67661,6.822),(5.538,8.346));
( (1.83708,7.062),(5.31128,7.938));
( (1.89551,7.026),(5.55452,8.706));
( (3.33754,6.876),(4.85081,8.124));
( (1.41082,6.882),(5.53643,8.118));
( (0.0,0.0),(3.336,0.0));
( (2.90341,7.278),(4.49074,8.716));
( (-0.520302,-2.824),(2.72683,0.028));
( (0.0,0.0),(3.336,0.0));
( (0.602672,6.966),(6.46417,8.742));
( (0.662092,-2.01),(3.40713,0.522));
( (1.67953,7.146),(5.12354,8.946));
( (0.54285,3.062),(12.849,3.938));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.476425,0.00200002),(13.4406,8.998));
( (0.0,0.0),(3.336,0.0));
( (0.937632,3.188),(5.62865,8.956));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.541769,0.00200002),(6.62352,8.998));
( (0.888221,-0.00399998),(10.5632,9.01));
( (1.52475,-0.046),(12.9638,9.124));
( (0.985632,3.188),(5.39161,8.8));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.045873,-0.00399998),(11.0768,7.1));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.996425,0.00200002),(3.27892,5.998));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.996425,0.00200002),(4.00621,8.998));
( (-0.0854598,-0.094),(7.76753,7.076));
( (1.34103,-0.106),(12.2583,6.154));
( (2.02854,-0.07),(8.27535,9.208));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0))

|]};;


let Helvetica_BoldOblique =
{Name="Helvetica-BoldOblique"; Width=12.0; Height=12.0;
Descr=[|3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
5.68799;
6.672;
6.672;
10.6679;
8.66382;
3.336;
3.99591;
3.99591;
4.66791;
7.008;
3.336;
3.99591;
3.336;
3.336;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
6.672;
3.99591;
3.99591;
7.008;
7.008;
7.008;
7.33191;
11.6999;
8.66382;
8.66382;
8.66382;
8.66382;
8.00391;
7.33191;
9.336;
8.66382;
3.336;
6.672;
8.66382;
7.33191;
9.99591;
8.66382;
9.336;
8.00391;
9.336;
8.66382;
8.00391;
7.33191;
8.66382;
8.00391;
11.3278;
8.00391;
8.00391;
7.33191;
3.99591;
3.336;
3.99591;
7.008;
6.672;
3.336;
6.672;
7.33191;
6.672;
7.33191;
6.672;
3.99591;
7.33191;
7.33191;
3.336;
3.336;
6.672;
3.336;
10.6679;
7.33191;
7.33191;
7.33191;
7.33191;
4.66791;
6.672;
3.99591;
7.33191;
6.672;
9.336;
6.672;
6.672;
6.0;
4.66791;
3.35999;
4.66791;
7.008;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.99591;
6.672;
6.672;
2.00391;
6.672;
6.672;
6.672;
6.672;
2.8559;
6.0;
6.672;
3.99591;
3.99591;
7.33191;
7.33191;
3.336;
6.672;
6.672;
6.672;
3.336;
3.336;
6.672;
4.19989;
3.336;
6.0;
6.0;
6.672;
12.0;
12.0;
3.336;
7.33191;
3.336;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.336;
3.99591;
3.99591;
3.99591;
12.0;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
12.0;
3.336;
4.43994;
3.336;
3.336;
3.336;
3.336;
7.33191;
9.336;
12.0;
4.37988;
3.336;
3.336;
3.336;
3.336;
3.336;
10.6679;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
3.336;
7.33191;
11.3278;
7.33191;
3.336;
3.336;
3.336;
3.336
|];
Descr_bbox=[|( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.12317,0.108994),(4.75987,8.75));
( (1.7649,5.946),(6.70337,9.054));
( (0.549279,-0.254),(7.96569,8.608));
( (0.341138,-1.396),(8.13346,8.76));
( (0.926162,-0.166),(10.7671,8.148));
( (0.0650773,-0.238),(8.19935,9.676));
( (2.3867,5.63),(4.66987,8.75));
( (0.505041,-2.424),(5.24745,8.748));
( (0.0847619,-2.424),(4.95557,8.748));
( (1.96009,4.62),(5.95609,8.76));
( (0.974352,-0.404),(7.08843,5.404));
( (0.682538,-1.964),(3.29876,1.876));
( (0.776224,2.184),(4.38712,3.816));
( (1.12636,0.124),(3.29876,1.876));
( (0.163139,0.25),(5.24587,8.75));
( (0.722945,0.196),(7.19007,8.804));
( (2.43303,0.26),(6.71348,8.814));
( (0.114589,0.238),(7.48381,8.34));
( (0.589342,-0.178),(7.33123,9.208));
( (1.16198,0.25),(7.72283,8.858));
( (0.414465,-0.292),(7.39515,8.756));
( (0.671678,-0.274),(7.28308,9.382));
( (1.28526,0.26),(7.85515,8.756));
( (0.425874,-0.22),(7.57304,9.214));
( (0.600677,-0.16),(7.42672,9.382));
( (1.10567,0.0266667),(4.14898,5.876));
( (0.682538,-1.964),(4.14898,5.876));
( (1.36135,0.09),(7.99966,5.898));
( (0.765795,0.78),(7.51755,5.22));
( (0.0961272,-0.404),(6.73443,5.404));
( (2.41277,0.124),(8.6413,9.152));
( (0.400972,-2.088),(12.0176,9.16));
( (-0.0367351,0.26),(8.08727,9.062));
( (1.15314,0.25),(9.18813,8.75));
( (0.928679,0.166),(9.33451,8.756));
( (1.15314,0.25),(9.12732,8.75));
( (1.15314,0.25),(9.29587,8.75));
( (1.15314,0.25),(9.10387,8.75));
( (-0.0580335,-0.328),(10.256,9.244));
( (0.887265,0.26),(9.75775,8.74));
( (1.15526,0.26),(4.75775,8.74));
( (0.539191,0.196),(7.75775,8.74));
( (1.15526,0.26),(10.3257,8.74));
( (1.15314,0.25),(7.45467,8.74));
( (1.15526,0.26),(10.7577,8.74));
( (1.15526,0.26),(9.75775,8.74));
( (0.827946,0.214),(10.0791,8.786));
( (1.15526,0.26),(9.38769,8.75));
( (0.827946,-0.158),(10.0791,8.786));
( (1.15526,0.26),(9.3145,8.75));
( (0.447409,-0.238),(9.1229,9.214));
( (1.99434,0.26),(9.31587,8.75));
( (1.58025,0.22),(9.75775,8.74));
( (2.11975,0.26),(9.59575,8.74));
( (2.01375,0.26),(13.0417,8.74));
( (0.319265,0.26),(9.62175,8.74));
( (2.18175,0.26),(9.65775,8.74));
( (0.413139,0.25),(8.79587,8.75));
( (0.762529,-2.124),(6.05227,9.1));
( (2.20387,0.25),(4.00914,8.75));
( (-0.569471,-2.124),(4.72027,9.1));
( (1.02949,3.686),(6.56148,8.786));
( (-0.672109,-1.92),(6.70644,-1.08));
( (2.30592,5.25),(4.5891,8.37));
( (0.223237,-0.34),(7.08236,7.106));
( (1.17445,-0.256),(7.94027,8.74));
( (0.623697,-0.268),(6.89451,7.268));
( (0.75557,-0.262),(8.69775,8.74));
( (0.679773,-0.19),(6.92752,7.202));
( (1.21526,0.26),(5.72737,9.124));
( (-0.134967,-3.142),(8.18835,6.822));
( (1.21526,0.26),(8.26413,8.74));
( (1.21271,0.248),(4.70814,8.78887));
( (-0.0711427,-2.066),(4.71461,8.81931));
( (1.21526,0.26),(8.27858,8.74));
( (1.18678,0.126),(4.72623,8.874));
( (1.21526,0.26),(12.1471,7.382));
( (1.21526,0.26),(8.23437,7.184));
( (0.644747,-0.22),(7.83715,7.22));
( (0.577594,-2.74),(8.17624,7.304));
( (0.182068,-2.74),(8.2467,6.822));
( (1.21526,0.26),(6.30172,6.942));
( (0.248427,-0.142),(6.96637,7.154));
( (1.35463,-0.16),(5.059,7.74));
( (1.20309,-0.244),(8.27263,6.74));
( (1.30663,0.106),(7.57063,6.74));
( (1.49263,0.26),(10.6246,6.74));
( (0.247265,0.26),(7.82863,6.74));
( (0.545051,-2.178),(7.88863,6.74));
( (0.211614,-0.19),(7.04828,7.19));
( (1.4527,-2.088),(6.11772,9.088));
( (0.504762,-2.424),(3.83945,8.748));
( (0.370181,-2.088),(5.03675,9.082));
( (1.57606,1.798),(6.73618,4.214));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.728025,-1.75),(4.36154,6.876));
( (0.701052,-1.408),(6.86815,8.186));
( (0.376012,0.00400003),(7.06991,8.382));
( (-1.98686,0.25),(5.93987,8.75));
( (1.4041,0.25),(8.45486,8.096));
( (-0.163761,-2.472),(8.33514,9.274));
( (0.977232,-2.406),(7.58914,9.178));
( (0.854698,1.354),(8.11832,7.658));
( (1.76618,5.94),(3.75377,9.06));
( (2.09064,5.25),(6.5891,8.37));
( (1.58263,0.492),(7.18038,5.448));
( (1.60153,0.564),(4.27381,5.4));
( (0.996433,0.576),(3.67381,5.412));
( (1.21314,0.25),(8.77937,9.124));
( (1.21314,0.25),(8.77937,9.124));
( (0.0,0.0),(3.336,0.0));
( (0.502039,2.87),(7.56186,4.13));
( (1.03312,-1.952),(7.233,8.884));
( (0.182896,-1.932),(7.233,8.884));
( (1.62578,3.756),(3.28723,5.244));
( (0.0,0.0),(3.336,0.0));
( (1.65608,-2.156),(8.74256,8.932));
( (1.5594,2.0),(4.91395,5.0));
( (0.898797,-1.37),(3.18197,1.75));
( (0.804422,-1.814),(5.20238,1.846));
( (2.3867,5.63),(6.89798,8.75));
( (1.13923,1.022),(6.4807,5.954));
( (1.12636,0.124),(11.2979,1.876));
( (0.837828,0.014),(12.4591,8.98));
( (0.0,0.0),(3.336,0.0));
( (-0.155729,-2.176),(7.06422,6.81));
( (0.0,0.0),(3.336,0.0));
( (2.48626,7.14),(4.45566,8.94));
( (2.57366,7.14),(5.30826,8.94));
( (2.0592,7.072),(5.8752,8.836));
( (1.69702,6.846),(5.69189,9.07));
( (1.8865,7.972),(5.69896,9.028));
( (2.08748,7.008),(5.54545,8.748));
( (3.49114,7.768),(5.12233,9.232));
( (1.49114,7.768),(5.89523,9.232));
( (0.0,0.0),(3.336,0.0));
( (2.87789,7.254),(4.51626,8.74));
( (0.294092,-2.95),(3.86341,-0.00200002));
( (0.0,0.0),(3.336,0.0));
( (0.573657,7.14),(6.30826,8.94));
( (0.588063,-2.076),(3.46331,0.804));
( (2.46098,7.17),(6.27698,8.934));
( (0.526039,2.87),(12.9139,4.13));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0531393,0.25),(13.2359,8.75));
( (0.0,0.0),(3.336,0.0));
( (0.703922,3.02),(5.86198,8.902));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.7043,0.25),(7.55052,8.75));
( (0.181283,0.028),(10.8317,8.894));
( (0.235283,-0.304),(13.6722,8.774));
( (0.751922,3.02),(5.61615,8.932));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.393715,-0.304),(10.8079,6.34));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.21314,0.25),(4.27476,6.75));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (1.13642,0.25),(4.96349,8.75));
( (-0.153372,-0.394),(8.40538,6.304));
( (0.630169,-0.352),(11.7817,6.22));
( (1.15787,-0.562),(7.90781,9.304));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0));
( (0.0,0.0),(3.336,0.0))

|]};;


let Symbol =
{Name="Symbol"; Width=12.504; Height=12.0;
Descr=[|3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.99591;
8.55597;
6.0;
6.58795;
9.99591;
9.336;
5.26794;
3.99591;
3.99591;
6.0;
6.58795;
3.0;
6.58795;
3.0;
3.336;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
6.0;
3.336;
3.336;
6.58795;
6.58795;
6.58795;
5.32782;
6.58795;
8.66382;
8.00391;
8.66382;
7.34399;
7.33191;
9.15582;
7.23596;
8.66382;
3.99591;
7.57196;
8.66382;
8.23187;
10.6679;
8.66382;
8.66382;
9.21588;
8.89197;
6.672;
7.10394;
7.33191;
8.27985;
5.26794;
9.21588;
7.73987;
9.53998;
7.33191;
3.99591;
10.3559;
3.99591;
7.89587;
6.0;
6.0;
7.57196;
6.58795;
6.58795;
5.92786;
5.26794;
6.25195;
4.93195;
7.23596;
3.94794;
7.23596;
6.58795;
6.58795;
6.91187;
6.25195;
6.58795;
6.58795;
6.25195;
6.58795;
7.23596;
5.26794;
6.91187;
8.55597;
8.23187;
5.91595;
8.23187;
5.92786;
5.75995;
2.39996;
5.75995;
6.58795;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
3.0;
7.43994;
2.96393;
6.58795;
2.00391;
8.55597;
6.0;
9.03589;
9.03589;
9.03589;
9.03589;
12.5039;
11.844;
7.23596;
11.844;
7.23596;
4.79993;
6.58795;
4.93195;
6.58795;
6.58795;
8.55597;
5.92786;
5.5199;
6.58795;
6.58795;
6.58795;
6.58795;
12.0;
7.23596;
12.0;
7.89587;
9.87598;
8.23187;
9.53998;
11.844;
9.21588;
9.21588;
9.87598;
9.21588;
9.21588;
8.55597;
8.55597;
8.55597;
8.55597;
8.55597;
8.55597;
8.55597;
9.21588;
8.55597;
9.47992;
9.47992;
10.68;
9.87598;
6.58795;
3.0;
8.55597;
7.23596;
7.23596;
12.5039;
11.844;
7.23596;
11.844;
7.23596;
5.92786;
3.94794;
9.47992;
9.47992;
9.43195;
8.55597;
4.60785;
4.60785;
4.60785;
4.60785;
4.60785;
4.60785;
5.92786;
5.92786;
5.92786;
5.92786;
3.0;
3.94794;
3.28784;
8.23187;
8.23187;
8.23187;
4.60785;
4.60785;
4.60785;
4.60785;
4.60785;
4.60785;
5.92786;
5.92786;
5.92786;
3.0
|];
Descr_bbox=[|( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (1.232,0.328),(2.768,7.608));
( (0.0700001,0.568),(7.87,8.608));
( (0.266,0.392),(5.734,7.608));
( (-0.106,0.67),(5.33,8.33));
( (0.304,-0.8),(9.71,7.794));
( (0.244,0.28),(9.468,8.136));
( (0.232,0.532),(4.648,5.924));
( (0.496,-2.68),(3.46,7.68));
( (0.54,-2.686),(3.504,7.698));
( (0.672,1.498),(5.328,6.514));
( (-0.174,-0.246),(6.174,6.15));
( (0.54,-1.454),(2.4,1.93));
( (0.132,2.67),(6.42,3.33));
( (1.328,0.328),(2.672,1.672));
( (0.44,0.392),(3.488,7.608));
( (-0.032,0.278),(6.032,7.722));
( (1.344,0.392),(4.62,7.608));
( (0.272,0.562),(5.218,7.972));
( (0.362,0.472),(5.72,8.486));
( (0.112,0.392),(5.548,7.608));
( (0.614,0.574),(5.666,7.684));
( (0.154,-0.538),(5.804,7.662));
( (0.166,0.392),(5.254,7.54));
( (0.208,-0.208),(5.732,8.07));
( (0.13,0.374),(6.554,8.328));
( (1.328,0.328),(2.672,5.672));
( (1.088,-1.698),(2.948,5.672));
( (0.604,-0.132),(6.568,6.132));
( (0.132,1.67),(6.444,4.33));
( (0.432,-0.132),(6.396,6.132));
( (0.792,0.328),(4.924,7.896));
( (0.132,0.664),(6.444,5.348));
( (0.432,0.392),(8.592,7.608));
( (0.308,0.392),(6.744,7.596));
( (-0.296,0.392),(8.26,7.608));
( (-0.106,0.706),(7.118,7.668));
( (0.296,0.392),(6.964,7.608));
( (0.28,0.392),(8.72,7.596));
( (0.164,0.392),(7.662,7.608));
( (0.296,0.392),(8.704,7.608));
( (0.296,0.392),(3.704,7.608));
( (0.116,0.224),(7.356,8.324));
( (0.308,0.392),(8.276,7.596));
( (-0.0939998,0.392),(7.994,7.668));
( (0.59,0.392),(10.704,7.608));
( (0.626,0.296),(8.374,7.608));
( (0.298,0.266),(8.696,7.734));
( (0.296,0.392),(8.704,7.608));
( (0.304,0.266),(8.69,7.734));
( (0.296,0.392),(6.822,7.608));
( (0.256,0.436),(7.264,7.276));
( (0.556,0.392),(7.444,7.734));
( (-0.248,0.392),(8.176,7.614));
( (0.64,-2.732),(5.324,5.564));
( (0.046,0.394),(8.954,8.692));
( (0.152,0.436),(6.86,7.528));
( (0.404,0.392),(9.596,7.728));
( (0.056,0.748),(7.686,7.252));
( (0.538,-1.65),(3.094,7.65));
( (1.72,0.72),(8.42275,5.28));
( (-0.0939999,-1.65),(2.462,7.65));
( (0.178,0.67),(7.822,8.758));
( (-0.024,-3.276),(6.024,-2.724));
( (5.76,10.284),(13.08,10.716));
( (0.268,0.164),(7.608,5.788));
( (0.352,-1.784),(6.672,8.872));
( (-0.036,-2.72),(6.084,5.552));
( (0.196,0.652),(5.948,9.444));
( (0.208,-0.492),(4.984,5.908));
( (0.34,-2.266),(5.72,7.768));
( (0.368,-2.644),(5.712,5.612));
( (0.368,-2.608),(6.798,6.63));
( (0.434,0.49),(3.626,5.638));
( (0.304,-2.26),(7.54,5.588));
( (0.518,0.392),(6.986,5.752));
( (0.08,0.436),(6.632,8.972));
( (0.052,-2.62),(6.656,5.608));
( (0.392,0.392),(5.684,5.74));
( (0.01,0.00800002),(6.02,6.082));
( (-0.248,0.268),(6.644,5.504));
( (0.292,0.26),(5.72,8.704));
( (0.424,-2.608),(5.576,5.456));
( (0.256,0.068),(7.284,5.516));
( (0.368,0.256),(4.956,5.552));
( (-0.0999999,0.676),(6.576,5.66));
( (0.088,0.58),(7.726,6.588));
( (0.31,0.556),(8.69,5.668));
( (0.64,-2.588),(5.372,9.704));
( (-0.128,-2.296),(8.14,6.408));
( (0.7,-2.636),(5.348,8.62));
( (1.014,-2.65),(5.082,7.65));
( (0.58,-2.124),(1.42,8.076));
( (0.918,-2.65),(4.986,7.65));
( (0.586,2.238),(6.372,3.63));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.0,0.0),(3.0,0.0));
( (0.364,0.392),(7.996,7.396));
( (0.17,4.95),(2.786,8.454));
( (0.616,0.67),(6.58,8.132));
( (-2.36,0.392),(3.88,7.608));
( (0.598,1.592),(8.414,5.678));
( (-0.09,-2.734),(5.91,7.71));
( (0.388,-0.608),(7.612,6.596));
( (1.252,-0.516),(6.748,6.516));
( (1.428,-0.652),(7.596,6.14));
( (1.344,-0.436),(7.68,6.572));
( (0.5,-0.156),(12.5,6.156));
( (0.516,-0.156),(11.436,6.156));
( (0.844,0.552),(7.156,11.472));
( (0.552,-0.156),(11.472,6.156));
( (0.844,-0.472),(7.156,10.448));
( (0.248,4.248),(3.74,7.728));
( (-0.168,0.664),(6.18,8.168));
( (0.164,5.26),(4.828,9.424));
( (0.444,0.67),(6.408,8.132));
( (-0.096,-0.096),(6.096,6.096));
( (0.592,1.298),(7.396,5.72));
( (0.412,-0.872),(5.48,9.396));
( (0.328,1.328),(4.66,5.66));
( (-0.096,1.328),(6.216,5.672));
( (-0.036,-0.262),(6.264,6.298));
( (0.168,0.67),(6.456,5.33));
( (0.598,1.226),(6.378,4.738));
( (1.328,0.328),(10.672,1.672));
( (3.664,-1.44),(4.336,12.12));
( (-0.72,2.664),(12.6,3.336));
( (0.478,-0.338),(7.33,7.402));
( (2.256,0.056),(8.284,7.952));
( (-0.304,-0.732),(6.588,8.552));
( (0.224,0.304),(9.44,8.684));
( (2.224,-2.728),(10.672,7.152));
( (0.682,0.682),(8.318,7.318));
( (0.682,0.682),(8.33,7.318));
( (0.574,0.586),(9.33,8.354));
( (0.67,0.392),(8.33,6.33));
( (0.67,0.67),(8.33,6.778));
( (0.506,0.67),(8.342,5.33));
( (0.512,-1.336),(8.348,5.324));
( (0.658,-0.17),(8.132,6.182));
( (0.658,0.67),(8.494,5.33));
( (0.676,-1.336),(8.512,5.324));
( (0.646,-0.324),(6.166,4.324));
( (0.574,-1.02),(6.178,5.368));
( (0.554,0.67),(9.098,8.746));
( (0.234,-0.538),(7.974,8.306));
( (0.248,0.26),(8.74,7.74));
( (0.26,0.26),(8.74,7.74));
( (0.392,3.392),(9.954,7.608));
( (0.158,-1.638),(9.842,8.638));
( (-0.298,-0.632),(5.754,10.828));
( (0.4,2.4),(1.6,3.6));
( (0.35,-0.126),(8.33,3.33));
( (0.64,0.2),(7.36,5.648));
( (0.712,0.352),(7.288,6.076));
( (0.472,0.152),(12.522,5.848));
( (0.484,0.11),(11.392,5.89));
( (0.11,-0.392),(6.89,10.516));
( (0.596,0.11),(11.504,5.89));
( (0.11,0.472),(6.89,11.38));
( (0.616,0.652),(5.372,9.324));
( (0.622,-2.664),(3.994,8.664));
( (0.248,0.26),(8.74,7.74));
( (0.272,0.248),(8.752,7.728));
( (0.206,3.392),(8.294,7.258));
( (0.49,-1.732),(8.662,9.354));
( (0.688,-4.008),(5.44,10.62));
( (0.688,-1.02),(1.312,11.1));
( (0.688,-3.632),(5.44,10.996));
( (-0.33,-0.742),(3.762,11.33));
( (-0.33,-0.948),(0.33,11.1));
( (-0.33,-1.33),(3.75,10.742));
( (2.676,-1.368),(5.532,10.644));
( (0.432,-0.65),(3.324,11.59));
( (2.688,-0.656),(5.544,11.296));
( (2.676,-0.96),(3.324,11.22));
( (0.0,0.0),(3.0,0.0));
( (0.006,-2.664),(3.378,8.664));
( (0.104,-1.756),(3.764,10.696));
( (3.502,-0.624),(8.182,11.484));
( (3.502,-1.056),(4.498,11.7));
( (-0.0499999,-1.484),(4.498,10.624));
( (0.56,-3.02),(5.312,11.608));
( (4.688,-1.02),(5.312,11.1));
( (0.56,-3.62),(5.312,11.008));
( (0.274,-0.742),(4.33,11.33));
( (3.67,-0.948),(4.33,11.1));
( (0.25,-1.33),(4.33,10.742));
( (0.468,-1.368),(3.324,10.644));
( (2.676,-0.644),(5.568,11.596));
( (0.468,-0.65),(3.324,11.302));
( (0.0,0.0),(3.0,0.0))

|]};;


end module with
type font and font_description;
value  Courier and Courier_Oblique and Courier_Bold and Courier_BoldOblique
and Times_Roman and Times_Bold and Times_Italic and Times_BoldItalic
and Helvetica and Helvetica_Bold and Helvetica_Oblique
and Helvetica_BoldOblique
and Symbol;;
